SystemOrganization addCategory: #'Magritte-Core'!
SystemOrganization addCategory: #'Magritte-Core-Model'!
SystemOrganization addCategory: #'Magritte-Core-Description'!
SystemOrganization addCategory: #'Magritte-Core-Accessor'!
SystemOrganization addCategory: #'Magritte-Core-Memento'!
SystemOrganization addCategory: #'Magritte-Core-Relation'!
SystemOrganization addCategory: #'Magritte-Core-Visitor'!
SystemOrganization addCategory: #'Magritte-Core-Builder'!
SystemOrganization addCategory: #'Magritte-Core-Exception'!
SystemOrganization addCategory: #'Magritte-Core-Utility'!

SmaCCScanner subclass: #MARelationScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MARelationScanner class methodsFor: 'generated-initialization' stamp: 'lr 8/13/2005 13:02'!
initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(10 'AND' 4) #(10 'NOT' 1) #(10 'OR' 5) #(10 'false' 6) #(10 'nil' 2) #(10 'true' 7)) 
		do: 
			[:each | 
			(keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2)
				put: each last].
	^keywordMap! !

!MARelationScanner class methodsFor: 'generated-comments' stamp: 'lr 8/13/2005 13:02'!
scannerDefinitionComment

	"<unary>			: [a-zA-Z] [a-zA-Z0-9]* ;
<number>		: [\-]? [0-9] [0-9]* ;
<string>			: \' [^\']* \' (\' [^\']* \')* ;
<keyword>		: <unary> \: ;
<binary>		: [\~\-\!!\@\%\&\*\+\=\\\|\?\/\>\<\,] [\~\!!\@\%\&\*\+\=\\\|\?\/\>\<\,]? ;
<whitespace>		: \s+ ;
<comment>		: \"" [^\""]* \"" ;"! !

!MARelationScanner methodsFor: 'generated-tokens' stamp: 'lr 8/13/2005 13:02'!
emptySymbolTokenId
	^30! !

!MARelationScanner methodsFor: 'generated-tokens' stamp: 'lr 8/13/2005 13:02'!
errorTokenId
	^31! !

!MARelationScanner methodsFor: 'generated-scanner' stamp: 'lr 8/13/2005 13:02'!
scan1
	
	[
	[self step.
	currentCharacter ~~ $'] whileTrue.
	self recordMatch: #(12).
	self step.
	currentCharacter == $'] 
			whileTrue: [].
	^self reportLastMatch! !

!MARelationScanner methodsFor: 'generated-scanner' stamp: 'lr 8/13/2005 13:02'!
scanForToken
	self step.
	((currentCharacter between: $A and: $Z) 
		or: [currentCharacter between: $a and: $z]) 
			ifTrue: 
				[
				[self recordMatch: #(10).
				self step.
				currentCharacter isDigit or: 
						[(currentCharacter between: $A and: $Z) 
							or: [currentCharacter between: $a and: $z]]] 
						whileTrue.
				currentCharacter == $: ifTrue: [^self recordAndReportMatch: #(13)].
				^self reportLastMatch].
	(currentCharacter == $!! or: 
			[(currentCharacter between: $% and: $&) or: 
					[(currentCharacter between: $* and: $,) or: 
							[currentCharacter == $/ or: 
									[(currentCharacter between: $< and: $@) or: 
											[currentCharacter == $\ 
												or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
		ifTrue: 
			[self recordMatch: #(14).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: [^self recordAndReportMatch: #(14)].
			^self reportLastMatch].
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(11).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^self reportLastMatch].
	(currentCharacter isSeparator or: [currentCharacter == $]) 
		ifTrue: 
			[
			[self recordMatch: #whitespace.
			self step.
			currentCharacter isSeparator or: [currentCharacter == $]] 
					whileTrue.
			^self reportLastMatch].
	currentCharacter == $" 
		ifTrue: 
			[
			[self step.
			currentCharacter ~~ $"] whileTrue.
			^self recordAndReportMatch: #comment].
	currentCharacter == $' ifTrue: [^self scan1].
	currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(8)].
	currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(9)].
	currentCharacter == $- 
		ifTrue: 
			[self recordMatch: #(3 14).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: [^self recordAndReportMatch: #(14)].
			currentCharacter isDigit 
				ifTrue: 
					[
					[self recordMatch: #(11).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	^self reportLastMatch! !

Error subclass: #MAError
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

MAError subclass: #MAConcurrentError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

!MAError class methodsFor: 'instance-creation' stamp: 'lr 9/18/2005 18:17'!
on: aDescription
	^ self new 
		setDescription: aDescription; 
		signal.! !

!MAError methodsFor: 'accessing' stamp: 'lr 9/18/2005 18:04'!
description
	^ description! !

!MAError methodsFor: 'initialization' stamp: 'lr 9/18/2005 17:55'!
setDescription: aDescription
	self description: aDescription.! !

MAError subclass: #MAReadonlyError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

MAError subclass: #MAValidationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

MAValidationError subclass: #MAKindError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

!MAKindError methodsFor: 'accessing' stamp: 'lr 9/15/2005 14:04'!
explanation
	^ 'Invalid input given.'! !

MAValidationError subclass: #MAMultipleErrors
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

!MAMultipleErrors class methodsFor: 'instance-creation' stamp: 'lr 9/20/2005 21:36'!
on: aDescription errors: aCollection
	^ self new
		setDescription: aDescription;
		setCollection: aCollection;
		signal.! !

!MAMultipleErrors methodsFor: 'accessing' stamp: 'lr 9/18/2005 18:19'!
collection
	^ collection! !

!MAMultipleErrors methodsFor: 'initialization' stamp: 'lr 9/18/2005 18:19'!
setCollection: aCollection
	collection := aCollection! !

MAValidationError subclass: #MARangeError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

!MARangeError methodsFor: 'accessing' stamp: 'lr 9/15/2005 14:29'!
explanation
	| minimum maximum |
	minimum := self tag toString: self tag minimum.
	maximum := self tag toString: self tag maximum.
	^ String streamContents: [ :stream |
		stream nextPutAll: 'Input must be '.
		self tag maximum isNil
			ifTrue: [ stream nextPutAll: 'above '; nextPutAll: minimum ]
			ifFalse: [
				self tag minimum isNil
					ifTrue: [ stream nextPutAll: 'below '; nextPutAll: maximum ]
					ifFalse: [ stream nextPutAll: 'between '; nextPutAll: minimum; nextPutAll: ' and '; nextPutAll: maximum ] ].
		stream nextPutAll: '.' ].! !

MAValidationError subclass: #MARequiredError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Exception'!

!MARequiredError methodsFor: 'accessing' stamp: 'lr 9/15/2005 14:04'!
explanation
	^ 'Input is required but no input given.'! !

!MAValidationError class methodsFor: 'instance creation' stamp: 'lr 9/20/2005 21:35'!
on: aDescription
	^ self new setDescription: aDescription; signal.! !

!MAValidationError methodsFor: 'accessing' stamp: 'lr 9/17/2005 22:37'!
description
	^ description! !

!MAValidationError methodsFor: 'accessing' stamp: 'lr 9/15/2005 14:03'!
explanation
	self subclassResponsibility.! !

!MAValidationError methodsFor: 'initialization' stamp: 'lr 9/20/2005 21:33'!
setDescription: aDescription
	description := aDescription.! !

Error subclass: #MAFormatError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Visitor'!

Error subclass: #MAParseError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Visitor'!

!False methodsFor: '*Magritte-Core-converting' stamp: 'lr 5/8/2005 20:29'!
asLabel
	^ 'no'! !

Object subclass: #MABlockToRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MABlockToRelation class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
do: aBlock
	^ aBlock value: self new.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 5/8/2005 20:29'!
< anObject
	^ MASelectorRelation selector: #< with: anObject.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 5/8/2005 20:29'!
<= anObject
	^ MASelectorRelation selector: #<= with: anObject.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 5/8/2005 20:29'!
= anObject
	^ MASelectorRelation selector: #= with: anObject.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 5/8/2005 20:29'!
> anObject
	^ MASelectorRelation selector: #> with: anObject.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 5/8/2005 20:29'!
>= anObject
	^ MASelectorRelation selector: #>= with: anObject.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 5/8/2005 20:29'!
beginsWith: anObject
	^ MASelectorRelation selector: #beginsWith: with: anObject.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
between: aMinimum and: aMaximum 
	^ MASelectorRelation selector: #between:and: with: aMinimum with: aMaximum.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 5/8/2005 20:29'!
endsWith: anObject
	^ MASelectorRelation selector: #endsWith: with: anObject.! !

!MABlockToRelation methodsFor: 'testing-objects' stamp: 'lr 5/9/2005 10:07'!
hash
	^ self shouldNotImplement.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 5/8/2005 20:29'!
includes: anObject
	^ MASelectorRelation selector: #includes: with: anObject.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 5/8/2005 20:29'!
isEmpty
	^ MASelectorRelation selector: #isEmpty.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
isEven
	^ MASelectorRelation selector: #even.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
isFloat
	^ MASelectorRelation selector: #isFloat.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
isInteger
	^ MASelectorRelation selector: #isInteger.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
isNegative
	^ MASelectorRelation selector: #negative.! !

!MABlockToRelation methodsFor: 'testing-objects' stamp: 'lr 5/8/2005 20:29'!
isNil
	^ MASelectorRelation selector: #isNil.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
isOdd
	^ MASelectorRelation selector: #odd.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
isPositive
	^ MASelectorRelation selector: #positive.! !

!MABlockToRelation methodsFor: 'testing-magnitudes' stamp: 'lr 5/8/2005 20:29'!
isZero
	^ MASelectorRelation selector: #isZero.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 5/8/2005 20:29'!
matches: anObject
	^ MASelectorRelation selector: #matches:.! !

!MABlockToRelation methodsFor: 'testing-collection' stamp: 'lr 5/8/2005 20:29'!
notEmpty
	^ MASelectorRelation selector: #notEmpty.! !

!MABlockToRelation methodsFor: 'testing-objects' stamp: 'lr 5/8/2005 20:29'!
notNil
	^ MASelectorRelation selector: #notNil.! !

!MABlockToRelation methodsFor: 'testing-operators' stamp: 'lr 5/8/2005 20:29'!
~= anObject
	^ MASelectorRelation selector: #~= with: anObject.! !

Object subclass: #MABuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

MABuilder class
	instanceVariableNames: 'default'!

!MABuilder class methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:33'!
default
	default isNil
		ifTrue: [ default := self new ].
	^ default.! !

!MABuilder methodsFor: 'actions' stamp: 'lr 9/14/2005 23:27'!
build: anObject
	| description |
	^ anObject defaultContainer in: [ :container |
		anObject class allSelectors do: [ :each |
			(self isDescriptionSelector: each) ifTrue: [ 
				description := anObject perform: each.
				description isDescription
					ifTrue: [ container add: description ] ] ] ].! !

!MABuilder methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
isDescriptionSelector: aSelector
	^ aSelector notNil
		and: [ aSelector isUnary ]
		and: [ aSelector ~= #description ] 
		and: [ aSelector beginsWith: #description ].! !

MABuilder subclass: #MACachedBuilder
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 5/8/2005 20:29'!
build: anObject
	^ self cache
		at: anObject
		ifAbsentPut: [ super build: anObject ].! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
cache
	^ cache! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
cache: aDictionary
	cache := aDictionary! !

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 5/8/2005 20:29'!
flush
	self cache: IdentityDictionary new.! !

!MACachedBuilder methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:29'!
initialize
	super initialize.
	self flush; register.! !

!MACachedBuilder methodsFor: 'events' stamp: 'lr 5/8/2005 20:29'!
modified: anEvent
	(self isDescriptionSelector: anEvent itemSelector) 
		ifTrue: [ self flush ].! !

!MACachedBuilder methodsFor: 'events' stamp: 'lr 5/8/2005 20:29'!
register
	SystemChangeNotifier uniqueInstance
		noMoreNotificationsFor: self;
		notify: self ofSystemChangesOfItem: #method change: #Added using: #modified:;
		notify: self ofSystemChangesOfItem: #method change: #Modified using: #modified:;
		notify: self ofSystemChangesOfItem: #method change: #Removed using: #modified:.! !

Object subclass: #MACompatibility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core'!

!MACompatibility class methodsFor: 'as yet unclassified' stamp: 'lr 9/12/2005 17:36'!
classNamed: aString ifAbsent: aBlock
	^ (Smalltalk classNamed: aString) ifNil: aBlock.! !

!MACompatibility methodsFor: 'as yet unclassified' stamp: 'lr 9/14/2005 23:41'!
seeClassSide! !

Object subclass: #MAFileModel
	instanceVariableNames: 'contents mimetype filename'
	classVariableNames: 'MimeTypes'
	poolDictionaries: ''
	category: 'Magritte-Core-Model'!

!MAFileModel class methodsFor: 'accessing-defaults' stamp: 'lr 8/10/2005 19:33'!
defaultMimeType
	^ 'application/octet-stream'.! !

!MAFileModel class methodsFor: 'accessing-defaults' stamp: 'lr 8/10/2005 19:10'!
defaultMimeTypes
	^ #( 'ai' 'application/postscript' 'aif' 'audio/x-aiff' 'aifc' 'audio/x-aiff' 'aiff' 'audio/x-aiff' 'asc' 'text/plain' 'au' 'audio/basic' 'avi' 'video/x-msvideo' 'bcpio' 'application/x-bcpio' 'bin' 'application/octet-stream' 'c' 'text/plain' 'cc' 'text/plain' 'ccad' 'application/clariscad' 'cdf' 'application/x-netcdf' 'class' 'application/octet-stream' 'cpio' 'application/x-cpio' 'cpt' 'application/mac-compactpro' 'csh' 'application/x-csh' 'css' 'text/css' 'dcr' 'application/x-director' 'dir' 'application/x-director' 'dms' 'application/octet-stream' 'doc' 'application/msword' 'drw' 'application/drafting' 'dvi' 'application/x-dvi' 'dwg' 'application/acad' 'dxf' 'application/dxf' 'dxr' 'application/x-director' 'eps' 'application/postscript' 'etx' 'text/x-setext' 'exe' 'application/octet-stream' 'ez' 'application/andrew-inset' 'f' 'text/plain' 'f90' 'text/plain' 'fli' 'video/x-fli' 'gif' 'image/gif' 'gtar' 'application/x-gtar' 'gz' 'application/x-gzip' 'h' 'text/plain' 'hdf' 'application/x-hdf' 'hh' 'text/plain' 'hqx' 'application/mac-binhex40' 'htm' 'text/html' 'html' 'text/html' 'ice' 'x-conference/x-cooltalk' 'ief' 'image/ief' 'iges' 'model/iges' 'igs' 'model/iges' 'ips' 'application/x-ipscript' 'ipx' 'application/x-ipix' 'jpe' 'image/jpeg' 'jpeg' 'image/jpeg' 'jpg' 'image/jpeg' 'js' 'application/x-javascript' 'kar' 'audio/midi' 'latex' 'application/x-latex' 'lha' 'application/octet-stream' 'lsp' 'application/x-lisp' 'lzh' 'application/octet-stream' 'm' 'text/plain' 'man' 'application/x-troff-man' 'me' 'application/x-troff-me' 'mesh' 'model/mesh' 'mid' 'audio/midi' 'midi' 'audio/midi' 'mif' 'application/vnd.mif' 'mime' 'www/mime' 'mov' 'video/quicktime' 'movie' 'video/x-sgi-movie' 'mp2' 'audio/mpeg' 'mp3' 'audio/mpeg' 'mpe' 'video/mpeg' 'mpeg' 'video/mpeg' 'mpg' 'video/mpeg' 'mpga' 'audio/mpeg' 'ms' 'application/x-troff-ms' 'msh' 'model/mesh' 'nc' 'application/x-netcdf' 'oda' 'application/oda' 'pbm' 'image/x-portable-bitmap' 'pdb' 'chemical/x-pdb' 'pdf' 'application/pdf' 'pgm' 'image/x-portable-graymap' 'pgn' 'application/x-chess-pgn' 'png' 'image/png' 'pnm' 'image/x-portable-anymap' 'pot' 'application/mspowerpoint' 'ppm' 'image/x-portable-pixmap' 'pps' 'application/mspowerpoint' 'ppt' 'application/mspowerpoint' 'ppz' 'application/mspowerpoint' 'pre' 'application/x-freelance' 'prt' 'application/pro_eng' 'ps' 'application/postscript' 'qt' 'video/quicktime' 'ra' 'audio/x-realaudio' 'ram' 'audio/x-pn-realaudio' 'ras' 'image/cmu-raster' 'rgb' 'image/x-rgb' 'rm' 'audio/x-pn-realaudio' 'roff' 'application/x-troff' 'rpm' 'audio/x-pn-realaudio-plugin' 'rtf' 'text/rtf' 'rtx' 'text/richtext' 'scm' 'application/x-lotusscreencam' 'set' 'application/set' 'sgm' 'text/sgml' 'sgml' 'text/sgml' 'sh' 'application/x-sh' 'shar' 'application/x-shar' 'silo' 'model/mesh' 'sit' 'application/x-stuffit' 'skd' 'application/x-koan' 'skm' 'application/x-koan' 'skp' 'application/x-koan' 'skt' 'application/x-koan' 'smi' 'application/smil' 'smil' 'application/smil' 'snd' 'audio/basic' 'sol' 'application/solids' 'spl' 'application/x-futuresplash' 'src' 'application/x-wais-source' 'step' 'application/STEP' 'stl' 'application/SLA' 'stp' 'application/STEP' 'sv4cpio' 'application/x-sv4cpio' 'sv4crc' 'application/x-sv4crc' 'swf' 'application/x-shockwave-flash' 't' 'application/x-troff' 'tar' 'application/x-tar' 'tcl' 'application/x-tcl' 'tex' 'application/x-tex' 'texi' 'application/x-texinfo' 'texinfo' 'application/x-texinfo' 'tif' 'image/tiff' 'tiff' 'image/tiff' 'tr' 'application/x-troff' 'tsi' 'audio/TSP-audio' 'tsp' 'application/dsptype' 'tsv' 'text/tab-separated-values' 'txt' 'text/plain' 'unv' 'application/i-deas' 'ustar' 'application/x-ustar' 'vcd' 'application/x-cdlink' 'vda' 'application/vda' 'viv' 'video/vnd.vivo' 'vivo' 'video/vnd.vivo' 'vrml' 'model/vrml' 'wav' 'audio/x-wav' 'wrl' 'model/vrml' 'xbm' 'image/x-xbitmap' 'xlc' 'application/vnd.ms-excel' 'xll' 'application/vnd.ms-excel' 'xlm' 'application/vnd.ms-excel' 'xls' 'application/vnd.ms-excel' 'xlw' 'application/vnd.ms-excel' 'xml' 'text/xml' 'xpm' 'image/x-xpixmap' 'xwd' 'image/x-xwindowdump' 'xyz' 'chemical/x-pdb' 'zip' 'application/zip' ).! !

!MAFileModel class methodsFor: 'class initialization' stamp: 'lr 8/10/2005 19:33'!
initialize
	MimeTypes := Dictionary new.
	1 to: self defaultMimeTypes size by: 2 do: [ :index |
		MimeTypes
			at: (self defaultMimeTypes at: index)
			put: (self defaultMimeTypes at: index + 1) ].! !

!MAFileModel class methodsFor: 'accessing' stamp: 'lr 8/10/2005 19:34'!
mimetypeFor: aString
	^ self mimetypes at: aString ifAbsent: [ self defaultMimeType ].! !

!MAFileModel class methodsFor: 'accessing' stamp: 'lr 8/10/2005 19:34'!
mimetypes
	^ MimeTypes.! !

!MAFileModel methodsFor: 'comparing' stamp: 'lr 8/10/2005 19:53'!
= anObject
	^ self species = anObject species
		and: [ self contents = anObject contents ]
		and: [ self filename = anObject filename ]
		and: [ self mimetype = anObject mimetype ].! !

!MAFileModel methodsFor: 'accessing' stamp: 'lr 8/10/2005 19:37'!
contents
	^ contents ifNil: [ ByteArray new ].! !

!MAFileModel methodsFor: 'accessing' stamp: 'lr 8/10/2005 18:13'!
contents: aByteArray
	contents := aByteArray! !

!MAFileModel methodsFor: 'convenience' stamp: 'lr 8/10/2005 19:40'!
extension
	^ self filename copyAfterLast: $..! !

!MAFileModel methodsFor: 'accessing' stamp: 'lr 8/10/2005 19:37'!
filename
	^ filename ifNil: [ String new ].! !

!MAFileModel methodsFor: 'accessing' stamp: 'lr 8/10/2005 18:15'!
filename: aString
	filename := aString! !

!MAFileModel methodsFor: 'comparing' stamp: 'lr 8/10/2005 19:54'!
hash
	^ (self contents hash bitXor: self filename hash) bitXor: self mimetype hash.! !

!MAFileModel methodsFor: 'testing-types' stamp: 'lr 8/10/2005 20:06'!
isApplication
	"Return true if the mimetype of the receiver is application-data. This message will match types like: application/postscript, application/zip, application/pdf, etc."

	^ self maintype = 'application'.! !

!MAFileModel methodsFor: 'testing-types' stamp: 'lr 9/9/2005 11:12'!
isAudio
	"Return true if the mimetype of the receiver is audio-data. This message will match types like: audio/basic, audio/tone, audio/mpeg, etc."

	^ self maintype = 'audio'.! !

!MAFileModel methodsFor: 'testing' stamp: 'lr 8/12/2005 08:53'!
isEmpty
	^ contents isNil
		or: [ filename isNil ]
		or: [ mimetype isNil ].! !

!MAFileModel methodsFor: 'testing-types' stamp: 'lr 8/10/2005 20:07'!
isImage
	"Return true if the mimetype of the receiver is image-data. This message will match types like: image/jpeg, image/gif, image/png, image/tiff, etc."

	^ self maintype = 'image'.! !

!MAFileModel methodsFor: 'testing-types' stamp: 'lr 8/10/2005 20:07'!
isText
	"Return true if the mimetype of the receiver is text-data. This message will match types like: text/plain, text/html, text/sgml, text/css, text/xml, text/richtext, etc."

	^ self maintype = 'text'.! !

!MAFileModel methodsFor: 'testing-types' stamp: 'lr 8/10/2005 20:07'!
isVideo
	"Return true if the mimetype of the receiver is video-data. This message will match types like: video/mpeg, video/quicktime, etc."

	^ self maintype = 'video'.! !

!MAFileModel methodsFor: 'convenience' stamp: 'lr 8/10/2005 18:17'!
maintype
	^ self mimetype copyUpTo: $/.! !

!MAFileModel methodsFor: 'accessing' stamp: 'lr 8/10/2005 19:36'!
mimetype
	^ mimetype ifNil: [ self class mimetypeFor: self extension ].! !

!MAFileModel methodsFor: 'accessing' stamp: 'lr 8/10/2005 18:15'!
mimetype: aString
	mimetype := aString! !

!MAFileModel methodsFor: 'convenience' stamp: 'lr 8/10/2005 20:17'!
size
	^ self contents size.! !

!MAFileModel methodsFor: 'convenience' stamp: 'lr 8/10/2005 18:17'!
subtype
	^ self mimetype copyAfter: $/.! !

Object subclass: #MAObject
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core'!

!MAObject commentStamp: '<historical>' prior: 0!
I provide some functions for all magritte objects. Magritte is a powerfull meta-description that allows one to create user-interfaces elements easily. Currently, only a web interface (for Seaside) is actively maintained. But a morph one is already working and it is easy to add new interfaces.

I implement a dictionary of properties.

With Magritte, describe once, display everywhere.!

MAObject subclass: #MAAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MAAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
canRead
	^ true! !

!MAAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
canWrite
	^ true! !

!MAAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printOn: aStream
	super printOn: aStream.
	self canRead ifTrue: [
		aStream nextPutAll: ' read: {'.
		self printRead: 'aModel' on: aStream.
		aStream nextPutAll: '}' ].
	self canWrite ifTrue: [
		aStream nextPutAll: ' write: {'.
		self printWrite: 'anObject' to: 'aModel' on: aStream.
		aStream nextPutAll: '}' ].! !

!MAAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printRead: aModel on: aStream! !

!MAAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printWrite: anObject to: aModel on: aStream! !

!MAAccessor methodsFor: 'model' stamp: 'lr 8/10/2005 10:49'!
read: aModel
	"Read from aModel using the access-strategy of the receiver."
	
	self subclassResponsibility.! !

!MAAccessor methodsFor: 'model' stamp: 'lr 8/10/2005 10:49'!
write: anObject to: aModel
	"Write to aModel using the access-strategy of the receiver and anObject as value."
	
	self subclassResponsibility.! !

MAAccessor subclass: #MABlockAccessor
	instanceVariableNames: 'readBlock writeBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MABlockAccessor class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MABlockAccessor class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
read: aReadBlock write: aWriteBlock
	^ self new
		readBlock: aReadBlock;
		writeBlock: aWriteBlock;
		yourself.! !

!MABlockAccessor methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:29'!
= anObject
	^ super = anObject
		and: [ self readBlock = anObject readBlock ]
		and: [ self writeBlock = anObject writeBlock ].! !

!MABlockAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
canRead
	^ self readBlock notNil.! !

!MABlockAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
canWrite
	^ self writeBlock notNil.! !

!MABlockAccessor methodsFor: 'comparing' stamp: 'lr 7/7/2005 14:27'!
hash
	^ super hash bitXor: (self readBlock hash bitXor: self writeBlock hash).! !

!MABlockAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printBlock: aBlock on: aStream
	aStream nextPutAll: aBlock decompile asString allButFirst allButLast.! !

!MABlockAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printRead: aModel on: aStream
	self printBlock: self readBlock on: aStream.
	aStream nextPutAll: ' value: '; nextPutAll: aModel asString.! !

!MABlockAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printWrite: anObject to: aModel on: aStream
	self printBlock: self writeBlock on: aStream.
	aStream nextPutAll: ' value: '; nextPutAll: aModel asString.
	aStream nextPutAll: ' value: '; nextPutAll: anObject asString.! !

!MABlockAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:29'!
read: aModel
	^ self readBlock value: aModel.! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
readBlock
	^ readBlock! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
readBlock: aBlock
	readBlock := aBlock! !

!MABlockAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:29'!
write: anObject to: aModel
	self writeBlock value: aModel value: anObject.! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
writeBlock
	^ writeBlock! !

!MABlockAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
writeBlock: aBlock
	writeBlock := aBlock! !

MAAccessor subclass: #MACascadeAccessor
	instanceVariableNames: 'accessor next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MACascadeAccessor class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
accessor: anAccessor next: aNextAccessor
	^ self new
		accessor: anAccessor;
		next: aNextAccessor; 
		yourself.! !

!MACascadeAccessor class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MACascadeAccessor class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
selectors: anArray
	^ anArray allButLast reverse
		inject: (MASelectorAccessor selector: anArray last)
		into: [ :next :accessor | 
			self 
				accessor: (MASelectorAccessor selector: accessor)
				next: next ].! !

!MACascadeAccessor methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:29'!
= anObject
	^ super = anObject
		and: [ self accessor = anObject accessor ]
		and: [ self next = anObject next ].! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
accessor
	^ accessor! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
accessor: anAccessor
	accessor := anAccessor! !

!MACascadeAccessor methodsFor: 'testing' stamp: 'lr 9/12/2005 17:30'!
canRead
	^ self accessor canRead and: [ self next canRead ].! !

!MACascadeAccessor methodsFor: 'testing' stamp: 'lr 9/12/2005 17:30'!
canWrite
	^ self accessor canRead and: [ self next canWrite ].! !

!MACascadeAccessor methodsFor: 'comparing' stamp: 'lr 7/7/2005 14:27'!
hash
	^ super hash bitXor: (self accessor hash bitXor: self next hash).! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
next
	^ next! !

!MACascadeAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
next: anAccessor
	next := anAccessor! !

!MACascadeAccessor methodsFor: 'copying' stamp: 'lr 5/8/2005 20:29'!
postCopy
	super postCopy.
	self accessor: self accessor copy.
	self next: self next copy.! !

!MACascadeAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printRead: aModel on: aStream
	self next 
		printRead: (String streamContents: [ :stream |
			self accessor 
				printRead: aModel 
				on: stream ])
		on: aStream.! !

!MACascadeAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printWrite: anObject to: aModel on: aStream
	self next
		printWrite: anObject
		to: (String streamContents: [ :stream |
			self accessor
				printRead: aModel
				on: stream ])
		on: aStream.! !

!MACascadeAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:29'!
read: aModel
	^ self next read: (self accessor read: aModel).! !

!MACascadeAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:29'!
write: anObject to: aModel
	self next write: anObject to: (self accessor read: aModel).! !

MAAccessor subclass: #MAContainerAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MAContainerAccessor class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MAContainerAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
canWrite
	^ false! !

!MAContainerAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:30'!
printRead: aModel on: aStream
	aStream nextPutAll: aModel asString.! !

!MAContainerAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:30'!
read: aModel
	^ aModel.! !

!MAContainerAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:30'!
write: anObject to: aModel
	self error: 'Not supposed to write to ' , aModel asString , '.'.! !

MAAccessor subclass: #MANullAccessor
	instanceVariableNames: 'uuid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MANullAccessor class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MANullAccessor class methodsFor: 'instance-creation' stamp: 'lr 8/25/2005 10:21'!
new
	^ self uuid: UUID new.! !

!MANullAccessor class methodsFor: 'instance-creation' stamp: 'lr 8/25/2005 10:20'!
uuid: anUUID
	^ self basicNew
		uuid: anUUID;
		yourself.! !

!MANullAccessor methodsFor: 'comparing' stamp: 'lr 8/25/2005 10:19'!
= anObject
	^ super = anObject
		and: [ self uuid = anObject uuid ].! !

!MANullAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
canRead
	^ false! !

!MANullAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
canWrite
	^ false! !

!MANullAccessor methodsFor: 'comparing' stamp: 'lr 8/25/2005 10:19'!
hash
	^ super hash bitXor: self uuid hash.! !

!MANullAccessor methodsFor: 'printing' stamp: 'lr 8/25/2005 10:22'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' uuid: '; print: self uuid.! !

!MANullAccessor methodsFor: 'model' stamp: 'lr 9/14/2005 23:39'!
read: aModel
	self shouldNotImplement.! !

!MANullAccessor methodsFor: 'accessing' stamp: 'lr 7/7/2005 14:26'!
uuid
	^ uuid! !

!MANullAccessor methodsFor: 'accessing' stamp: 'lr 7/7/2005 14:29'!
uuid: anObject
	uuid := anObject! !

!MANullAccessor methodsFor: 'model' stamp: 'lr 9/14/2005 23:39'!
write: anObject to: aModel
	self shouldNotImplement.! !

MAAccessor subclass: #MASelectorAccessor
	instanceVariableNames: 'readSelector writeSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

MASelectorAccessor subclass: #MAAutoSelectorAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MAAutoSelectorAccessor methodsFor: 'private' stamp: 'lr 9/14/2005 23:30'!
ensureReadAccessor: aClass
	(aClass selectors includes: self readSelector)
		ifTrue: [ ^ self ].
	aClass 
		compile: (String streamContents: [ :stream |
			stream nextPutAll: self readSelector; cr.
			stream tab; nextPutAll: '^ '; nextPutAll: self readSelector ])
		classified: #accessing.! !

!MAAutoSelectorAccessor methodsFor: 'private' stamp: 'lr 9/14/2005 23:30'!
ensureVariable: aClass
	(aClass allInstVarNames includes: self readSelector)
		ifTrue: [ ^ self ].
	aClass addInstVarName: self readSelector.! !

!MAAutoSelectorAccessor methodsFor: 'private' stamp: 'lr 9/14/2005 23:31'!
ensureWriteAccessor: aClass
	(aClass selectors includes: self writeSelector)
		ifTrue: [ ^ self ].
	aClass 
		compile: (String streamContents: [ :stream |
			stream nextPutAll: self writeSelector; space; nextPutAll: 'anObject'; cr.
			stream tab; nextPutAll: self readSelector; nextPutAll: ' := anObject' ])
		classified: #accessing.! !

!MAAutoSelectorAccessor methodsFor: 'model' stamp: 'lr 9/14/2005 23:31'!
read: aModel
	self ensureVariable: aModel class; ensureReadAccessor: aModel class.
	^ super read: aModel.! !

!MAAutoSelectorAccessor methodsFor: 'model' stamp: 'lr 9/14/2005 23:31'!
write: anObject to: aModel
	self ensureVariable: aModel class; ensureWriteAccessor: aModel class.
	super write: anObject to: aModel.! !

!MASelectorAccessor class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:34'!
isAbstract
	^ false! !

!MASelectorAccessor class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:34'!
read: aReadSelector write: aWriteSelector
	^ self new
		readSelector: aReadSelector;
		writeSelector: aWriteSelector;
		yourself.! !

!MASelectorAccessor class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:34'!
selector: aSelector
	^ self new
		selector: aSelector;
		yourself.! !

!MASelectorAccessor methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:32'!
= anObject
	^ super = anObject
		and: [ self readSelector = anObject readSelector ]
		and: [ self writeSelector = anObject writeSelector ].! !

!MASelectorAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:32'!
canRead
	^ self readSelector notNil.! !

!MASelectorAccessor methodsFor: 'testing' stamp: 'lr 5/8/2005 20:32'!
canWrite
	^ self writeSelector notNil.! !

!MASelectorAccessor methodsFor: 'comparing' stamp: 'lr 7/7/2005 14:28'!
hash
	^  super hash bitXor: (self readSelector hash bitXor: self writeSelector hash).! !

!MASelectorAccessor methodsFor: 'printing' stamp: 'lr 5/8/2005 20:32'!
printRead: aModel on: aStream
	aStream nextPutAll: aModel asString; space.
	aStream nextPutAll: self readSelector.! !

!MASelectorAccessor methodsFor: 'printing' stamp: 'lr 7/14/2005 11:43'!
printWrite: anObject to: aModel on: aStream
	aStream nextPutAll: aModel asString; space.
	aStream nextPutAll: self writeSelector; space.
	aStream nextPutAll: anObject asString.! !

!MASelectorAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:32'!
read: aModel
	^ aModel perform: self readSelector.! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
readSelector
	^ readSelector! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
readSelector: aSelector
	readSelector := aSelector.! !

!MASelectorAccessor methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:32'!
selector
	^ self readSelector.! !

!MASelectorAccessor methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:32'!
selector: aSelector
	self readSelector: aSelector asSymbol.
	self writeSelector: (aSelector copyWith: $:) asSymbol.! !

!MASelectorAccessor methodsFor: 'model' stamp: 'lr 5/8/2005 20:32'!
write: anObject to: aModel
	aModel perform: self writeSelector with: anObject.! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
writeSelector
	^ writeSelector! !

!MASelectorAccessor methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
writeSelector: aSelector
	writeSelector := aSelector.! !

MAAccessor subclass: #MAVariableAccessor
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Accessor'!

!MAVariableAccessor class methodsFor: 'testing' stamp: 'lr 5/9/2005 13:43'!
isAbstract
	^ false! !

!MAVariableAccessor class methodsFor: 'instance creation' stamp: 'lr 5/9/2005 13:43'!
name: aString
	^ self new
		name: aString;
		yourself.! !

!MAVariableAccessor methodsFor: 'comparing' stamp: 'lr 5/9/2005 13:38'!
= anObject
	^ super = anObject
		and: [ self name = anObject name ].! !

!MAVariableAccessor methodsFor: 'comparing' stamp: 'lr 5/9/2005 13:38'!
hash
	^ super hash bitXor: self name hash.! !

!MAVariableAccessor methodsFor: 'accessing' stamp: 'lr 5/9/2005 13:37'!
name
	^ name! !

!MAVariableAccessor methodsFor: 'accessing' stamp: 'lr 5/9/2005 13:37'!
name: aString
	name := aString! !

!MAVariableAccessor methodsFor: 'printing' stamp: 'lr 5/9/2005 13:42'!
printRead: aModel on: aStream
	aStream 
		nextPutAll: aModel asString;
		nextPutAll: ' instVarNamed: '; print: self name.! !

!MAVariableAccessor methodsFor: 'printing' stamp: 'lr 7/14/2005 11:43'!
printWrite: anObject to: aModel on: aStream
	aStream 
		nextPutAll: aModel asString; 
		nextPutAll: ' instVarNamed: '; print: self name;
		nextPutAll: ' put: '; nextPutAll: anObject asString.! !

!MAVariableAccessor methodsFor: 'model' stamp: 'lr 5/9/2005 13:38'!
read: aModel
	^ aModel instVarNamed: self name.! !

!MAVariableAccessor methodsFor: 'model' stamp: 'lr 5/9/2005 13:39'!
write: anObject to: aModel
	aModel instVarNamed: self name put: anObject.! !

MAObject subclass: #MADescription
	instanceVariableNames: 'accessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MADescription commentStamp: '<historical>' prior: 0!
I'm the base class of Magritte. All the descriptions of magritte are my subclasses. If you want one of your objects to have a user interface for an elements, find the most approriate of my subclasses. 

For example, your application need to ask a string to the user, use MAStringDescription. Create two methods to retrieve and store the string in you class and then create a method on the class side with a name begining with 'description', like this.

MyClass class>>descriptionTitle
	^ (MAStringDescription selector: #title label: 'Title' priority: 100)
		beRequired;
		yourself.

The selector #title is the name of the reader method, to retrieve the current value of the string (the default value if you prefer).
The writer is automatically guessed adding ':' to the reader, here #title:. You can specify you own writer using the MAAccessor classes (look at MADescription>>selector:label:priority: and MAAccessor subclasses).
The label is what will be printed near the input box to inform the user about what to do here.
If you have multiple description within the same object, the priority field is used to order them. Put a low priority for description printed first.

You can then add more properties to your description depending on the type of this description. All descriptions have those basic properties:
- required: Your user has to fill this field before being able to go on. Set or unset this propertie with beRequired or beOptional. Default: false.
- readonly: It is just an information, nothing to modify here. beReadonly/beWriteable. Default: false.
- visible: Does this description need to be displayed to the user ? beVisible/beHidden. Default: true.!

MADescription subclass: #MABasicDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MABasicDescription class methodsFor: 'accessing-defaults' stamp: 'lr 9/15/2005 10:58'!
defaultStringFormatter
	^ MAFormatter! !

!MABasicDescription class methodsFor: 'accessing-defaults' stamp: 'lr 9/15/2005 10:58'!
defaultStringParser
	^ MAParser! !

!MABasicDescription class methodsFor: 'accessing-defaults' stamp: 'lr 9/15/2005 10:38'!
defaultUndefined
	^ String new.! !

!MABasicDescription class methodsFor: 'accessing-description' stamp: 'lr 9/13/2005 23:50'!
descriptionStringFormatterClass
	^ (MASingleOptionDescription selector: #stringFormatterClass label: 'String Formatter Class' priority: 300 default: self defaultStringFormatterClass)
		options: (MADynamicObject on: [ self defaultStringFormatterClass withAllSubclasses ]);
		yourself.! !

!MABasicDescription class methodsFor: 'accessing-description' stamp: 'lr 9/13/2005 23:50'!
descriptionStringParserClass
	^ (MASingleOptionDescription selector: #stringParserClass label: 'String Parser Class' priority: 310 default: self defaultStringParserClass)
		options: (MADynamicObject on: [ self defaultStringParserClass withAllSubclasses ]);
		yourself.! !

!MABasicDescription class methodsFor: 'accessing-description' stamp: 'lr 9/15/2005 10:38'!
descriptionUndefined
	^ MAStringDescription selector: #undefined label: 'Undefined String' priority: 140 default: self defaultUndefinedString.! !

!MABasicDescription methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitBasicDescription: self.! !

!MABasicDescription methodsFor: 'converting' stamp: 'lr 5/8/2005 20:31'!
asContainer
	^ MAContainer with: self.! !

!MABasicDescription methodsFor: 'accessing' stamp: 'lr 9/15/2005 10:31'!
default	
	^ self propertyAt: #default ifAbsent: [ self class defaultDefault ].! !

!MABasicDescription methodsFor: 'accessing' stamp: 'lr 9/15/2005 10:31'!
default: anObject
	self propertyAt: #default put: anObject.! !

!MABasicDescription methodsFor: 'strings' stamp: 'lr 9/15/2005 10:53'!
fromString: aString
	^ self fromString: aString parser: self stringParser.! !

!MABasicDescription methodsFor: 'strings' stamp: 'lr 9/13/2005 21:46'!
fromString: aString parser: aParser
	^ aParser parse: aString description: self.! !

!MABasicDescription methodsFor: 'accessing-properties' stamp: 'lr 9/15/2005 10:42'!
stringFormatter
	^ self propertyAt: #stringFormatter ifAbsent: [ self class defaultStringFormatter ].! !

!MABasicDescription methodsFor: 'accessing-properties' stamp: 'lr 9/15/2005 10:43'!
stringFormatter: aClass
	self propertyAt: #stringFormatter put: aClass.! !

!MABasicDescription methodsFor: 'accessing-properties' stamp: 'lr 9/15/2005 10:43'!
stringParser
	^ self propertyAt: #stringParser ifAbsent: [ self class defaultStringParser ].! !

!MABasicDescription methodsFor: 'accessing-properties' stamp: 'lr 9/15/2005 10:43'!
stringParser: aClass
	self propertyAt: #stringParser put: aClass.! !

!MABasicDescription methodsFor: 'strings' stamp: 'lr 9/15/2005 10:53'!
toString: anObject
	^ self toString: anObject formatter: self stringFormatter.! !

!MABasicDescription methodsFor: 'strings' stamp: 'lr 9/13/2005 21:46'!
toString: anObject formatter: aFormatter
	^ aFormatter format: anObject description: self.! !

!MABasicDescription methodsFor: 'accessing-properties' stamp: 'lr 9/15/2005 10:32'!
undefined	
	^ self propertyAt: #undefined ifAbsent: [ self class defaultUndefined ].! !

!MABasicDescription methodsFor: 'accessing-properties' stamp: 'lr 9/15/2005 10:32'!
undefined: aString
	self propertyAt: #undefined put: aString.! !

!MABasicDescription methodsFor: 'validation' stamp: 'lr 9/18/2005 20:00'!
validate: anObject
	anObject isNil ifTrue: [ 
		self isRequired
			ifTrue: [ MARequiredError on: self ]
			ifFalse: [ ^ self ] ].
	(anObject isKindOf: self kind)
		ifFalse: [ MAKindError on: self ].! !

MABasicDescription subclass: #MABooleanDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MABooleanDescription commentStamp: '<historical>' prior: 0!
I'm a simple description for booleans. Forms should display me as a checkbox or something similar.!

!MABooleanDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:33'!
asLabel
	^ 'Check-Box'! !

!MABooleanDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MABooleanDescription methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitBooleanDescription: self.! !

!MABooleanDescription methodsFor: 'private' stamp: 'lr 5/8/2005 20:29'!
falseStrings
	^ #( 'false' 'f' 'no' 'n' '0' 'off' )! !

!MABooleanDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
kind
	^ Boolean! !

!MABooleanDescription methodsFor: 'private' stamp: 'lr 5/8/2005 20:29'!
trueStrings
	^ #( 'true' 't' 'yes' 'y' '1' 'on' )! !

MABasicDescription subclass: #MAClassDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAClassDescription class methodsFor: 'converting' stamp: 'lr 9/12/2005 16:51'!
asLabel
	^ 'Smalltalk Class'! !

!MAClassDescription class methodsFor: 'testing' stamp: 'lr 9/12/2005 16:52'!
isAbstract
	^ false! !

!MAClassDescription methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitClassDescription: self.! !

!MAClassDescription methodsFor: 'accessing' stamp: 'lr 9/12/2005 16:51'!
kind
	^ Class! !

MABasicDescription subclass: #MAColorDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAColorDescription commentStamp: '<historical>' prior: 0!
Use me if you want your user to choose a color.!

!MAColorDescription class methodsFor: 'converting' stamp: 'lr 5/23/2005 20:38'!
asLabel
	^ 'Color Field'! !

!MAColorDescription class methodsFor: 'testing' stamp: 'lr 5/9/2005 17:14'!
isAbstract
	^ false! !

!MAColorDescription methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitColorDescription: self.! !

!MAColorDescription methodsFor: 'accessing' stamp: 'lr 5/9/2005 17:13'!
kind
	^ Color! !

MABasicDescription subclass: #MAFileDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAFileDescription commentStamp: '<historical>' prior: 0!
If you want to ask your user for a file, just use me. I render a button for the user to browse his computer and select a file.!

!MAFileDescription class methodsFor: 'converting' stamp: 'lr 8/10/2005 19:46'!
asLabel
	^ 'Document'! !

!MAFileDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MAFileDescription methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitFileDescription: self.! !

!MAFileDescription methodsFor: 'accessing' stamp: 'lr 8/10/2005 19:39'!
kind
	^ MAFileModel! !

MABasicDescription subclass: #MAMagnitudeDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAMagnitudeDescription subclass: #MADateDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MADateDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:33'!
asLabel
	^ 'Date Field'! !

!MADateDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MADateDescription methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitDateDescription: self.! !

!MADateDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
kind
	^ Date! !

MAMagnitudeDescription subclass: #MADurationDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MADurationDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:33'!
asLabel
	^ 'Duration Field'! !

!MADurationDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MADurationDescription methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitDurationDescription: self.! !

!MADurationDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
kind
	^ Duration! !

!MAMagnitudeDescription class methodsFor: 'accessing-defaults' stamp: 'lr 9/15/2005 14:14'!
defaultMaximum
	^ nil! !

!MAMagnitudeDescription class methodsFor: 'accessing-defaults' stamp: 'lr 9/15/2005 14:12'!
defaultMinimum
	^ nil! !

!MAMagnitudeDescription class methodsFor: 'accessing-description' stamp: 'lr 9/15/2005 14:14'!
descriptionMaximum
	^ self selector: #maximum label: 'Maximum' priority: 410.! !

!MAMagnitudeDescription class methodsFor: 'accessing-description' stamp: 'lr 9/15/2005 14:14'!
descriptionMinimum
	^ self selector: #minimum label: 'Minimum' priority: 400.! !

!MAMagnitudeDescription methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitMagnitudeDescription: self.! !

!MAMagnitudeDescription methodsFor: 'accessing' stamp: 'lr 9/15/2005 14:16'!
maximum
	^ self propertyAt: #maximum ifAbsent: [ self class defaultMaximum ].! !

!MAMagnitudeDescription methodsFor: 'accessing' stamp: 'lr 9/15/2005 14:16'!
maximum: aMagnitudeOrNil
	^ self propertyAt: #maximum put: aMagnitudeOrNil.! !

!MAMagnitudeDescription methodsFor: 'accessing' stamp: 'lr 9/15/2005 14:15'!
minimum
	^ self propertyAt: #minimum ifAbsent: [ self class defaultMinimum ].! !

!MAMagnitudeDescription methodsFor: 'accessing' stamp: 'lr 9/15/2005 14:15'!
minimum: aMagnitudeOrNil
	^ self propertyAt: #minimum put: aMagnitudeOrNil.! !

!MAMagnitudeDescription methodsFor: 'validation' stamp: 'lr 9/18/2005 18:21'!
validate: anObject
	super validate: anObject.
	(self withinRange: anObject)
		ifFalse: [ MARangeError on: self ].! !

!MAMagnitudeDescription methodsFor: 'testing' stamp: 'lr 9/15/2005 14:20'!
withinRange: anObject
	^ (self minimum isNil or: [ self minimum <= anObject ]) 
		and: [ self maximum isNil or: [ self maximum >= anObject ] ].! !

MAMagnitudeDescription subclass: #MANumberDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MANumberDescription commentStamp: 'dc 8/24/2005 15:43' prior: 0!
Use me if you want to ask numbers to your customer.

The range of accepted values is not limited. You can restrict it using:

- #min:  set a minimum value for the range
- #max: set the maximum value accepted
- #min:max: set a minimum and a maximum
- #beInteger restrict to integer values
- #bePositive restrict to positive values (>= 0)
!

!MANumberDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:33'!
asLabel
	^ 'Number Field'! !

!MANumberDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MANumberDescription methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitNumberDescription: self.! !

!MANumberDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
kind
	^ Number! !

MAMagnitudeDescription subclass: #MATimeDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATimeDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:34'!
asLabel
	^ 'Time Field'! !

!MATimeDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:34'!
isAbstract
	^ false! !

!MATimeDescription methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitTimeDescription: self.! !

!MATimeDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:33'!
kind
	^ Time! !

MAMagnitudeDescription subclass: #MATimeStampDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATimeStampDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:34'!
asLabel
	^ 'Timestamp Field'! !

!MATimeStampDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:34'!
isAbstract
	^ false! !

!MATimeStampDescription methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitTimeStampDescription: self.! !

!MATimeStampDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:33'!
kind
	^ TimeStamp! !

MABasicDescription subclass: #MAReferenceDescription
	instanceVariableNames: 'reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAReferenceDescription subclass: #MAOptionDescription
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAOptionDescription subclass: #MAMultipleOptionDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAMultipleOptionDescription class methodsFor: 'testing' stamp: 'lr 9/13/2005 21:36'!
asLabel
	^ 'MO'! !

!MAMultipleOptionDescription class methodsFor: 'testing' stamp: 'lr 9/13/2005 09:31'!
isAbstract
	^ false! !

!MAMultipleOptionDescription methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitMultipleOptionDescription: self.! !

!MAMultipleOptionDescription methodsFor: 'testing' stamp: 'lr 9/13/2005 21:35'!
isSatisfiedBy: anObject
	^ (super isSatisfiedBy: anObject) and: [ 
		anObject allSatisfy: [ :each | 
			self options includes: each ] ].! !

!MAMultipleOptionDescription methodsFor: 'accessing' stamp: 'lr 9/13/2005 21:36'!
kind
	^ Collection! !

!MAOptionDescription class methodsFor: 'accessing-defaults' stamp: 'lr 9/12/2005 21:53'!
defaultExtensible
	^ false! !

!MAOptionDescription class methodsFor: 'accessing-defaults' stamp: 'lr 9/14/2005 22:38'!
defaultOptions
	^ OrderedCollection new! !

!MAOptionDescription class methodsFor: 'accessing-defaults' stamp: 'lr 9/13/2005 09:29'!
defaultSorted
	^ false! !

!MAOptionDescription class methodsFor: 'accessing-description' stamp: 'lr 9/14/2005 22:37'!
descriptionExtensible
	^ MABooleanDescription selector: #extensible label: 'Extensible' priority: 260 default: self defaultExtensible.! !

!MAOptionDescription class methodsFor: 'accessing-description' stamp: 'lr 9/14/2005 22:37'!
descriptionSorted
	^ MABooleanDescription selector: #sorted label: 'Sorted' priority: 250 default: self defaultSorted.! !

!MAOptionDescription methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitOptionDescription: self.! !

!MAOptionDescription methodsFor: 'accessing-dynamic' stamp: 'lr 9/13/2005 22:04'!
allOptions
	| list |
	list := self options copy asArray.
	self isSorted ifTrue: [ 
		list sort: [ :a :b | 
			(self reference toString: a) 
				caseInsensitiveLessOrEqual: (self reference toString: b) ] ].
	self isRequired 
		ifFalse: [ list := list copyWithFirst: nil ].
	^ list.! !

!MAOptionDescription methodsFor: 'actions' stamp: 'lr 9/13/2005 09:29'!
beExtensible
	self extensible: true.! !

!MAOptionDescription methodsFor: 'actions' stamp: 'lr 9/13/2005 09:29'!
beSorted
	self sorted: true.! !

!MAOptionDescription methodsFor: 'actions' stamp: 'lr 9/15/2005 11:42'!
beUnsorted
	self sorted: false.! !

!MAOptionDescription methodsFor: 'accessing-properties' stamp: 'lr 9/12/2005 21:49'!
extensible
	^ self propertyAt: #extensible ifAbsent: [ self class defaultExtensible ].! !

!MAOptionDescription methodsFor: 'accessing-properties' stamp: 'lr 9/12/2005 21:48'!
extensible: aBoolean
	^ self propertyAt: #extensible put: aBoolean.! !

!MAOptionDescription methodsFor: 'testing' stamp: 'lr 9/13/2005 07:22'!
isExtensible
	^ self extensible.! !

!MAOptionDescription methodsFor: 'testing' stamp: 'lr 9/13/2005 07:22'!
isSorted
	^ self sorted.! !

!MAOptionDescription methodsFor: 'accessing' stamp: 'lr 9/14/2005 22:38'!
options
	^ options ifNil: [ options := self class defaultOptions ].! !

!MAOptionDescription methodsFor: 'accessing' stamp: 'lr 9/13/2005 07:29'!
options: anArray
	options := anArray! !

!MAOptionDescription methodsFor: 'copying' stamp: 'lr 9/12/2005 21:39'!
postCopy
	super postCopy.
	self options: self options copy.! !

!MAOptionDescription methodsFor: 'accessing-properties' stamp: 'lr 9/12/2005 21:40'!
sorted
	^ self propertyAt: #sorted ifAbsent: [ self class defaultSorted ].! !

!MAOptionDescription methodsFor: 'accessing-properties' stamp: 'lr 9/12/2005 21:40'!
sorted: aBoolean
	^ self propertyAt: #sorted put: aBoolean.! !

MAOptionDescription subclass: #MASingleOptionDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MASingleOptionDescription class methodsFor: 'testing' stamp: 'lr 9/13/2005 21:37'!
asLabel
	^ 'SO'! !

!MASingleOptionDescription class methodsFor: 'testing' stamp: 'lr 9/13/2005 09:31'!
isAbstract
	^ false! !

!MASingleOptionDescription methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitSingleOptionDescription: self.! !

!MASingleOptionDescription methodsFor: 'testing' stamp: 'lr 9/15/2005 11:43'!
isSatisfiedBy: anObject
	^ (super isSatisfiedBy: anObject)
		and: [ self reference isSatisfiedBy: anObject ]
		and: [ self options includes: anObject ].! !

!MAReferenceDescription class methodsFor: 'accessing-defaults' stamp: 'lr 9/15/2005 11:47'!
defaultReference
	^ MAStringDescription new.! !

!MAReferenceDescription class methodsFor: 'accessing-description' stamp: 'lr 9/14/2005 22:36'!
descriptionReference
	^ (MASingleOptionDescription selector: #reference label: 'Description' priority: 400)
		! !

!MAReferenceDescription methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitReference: self.! !

!MAReferenceDescription methodsFor: 'copying' stamp: 'lr 9/12/2005 16:44'!
postCopy
	super postCopy.
	self reference: self reference copy.! !

!MAReferenceDescription methodsFor: 'accessing' stamp: 'lr 9/15/2005 11:47'!
reference
	^ reference ifNil: [ reference := self class defaultReference ].! !

!MAReferenceDescription methodsFor: 'accessing' stamp: 'lr 9/12/2005 16:42'!
reference: aDescription
	reference := aDescription! !

MAReferenceDescription subclass: #MATableReference
	instanceVariableNames: 'rowLabels columnLabels cellDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATableReference class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:34'!
asLabel
	^ 'Table'! !

!MATableReference class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultCellDescription
	^ self defaultCellDescriptionClasses first new.! !

!MATableReference class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultCellDescriptionClasses
	^ Array 
		with: MAStringDescription
		with: MANumberDescription
		with: MABooleanDescription.! !

!MATableReference class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultColumnLabels
	^ OrderedCollection new! !

!MATableReference class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultRowLables
	^ OrderedCollection new! !

!MATableReference class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:34'!
descriptionCellDescription
	^ (MASingleSelectionDescription selector: #cellDescription label: 'Type' priority: 270 default: self defaultCellDescription)
		options: (self defaultCellDescriptionClasses collect: [ :each |
			each new
				label: each description label; 
				yourself ]);
		beRequired;
		yourself.! !

!MATableReference class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:34'!
descriptionColumnLabels
	^ MATextDescription selector: #columnLabelsTextual label: 'Column Labels' priority: 250.! !

!MATableReference class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:34'!
descriptionDefault
	^ nil! !

!MATableReference class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:34'!
descriptionRequired
	^ nil! !

!MATableReference class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:34'!
descriptionRowLabels
	^ MATextDescription selector: #rowLabelsTextual label: 'Row Labels' priority: 260.! !

!MATableReference class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:34'!
isAbstract
	^ false! !

!MATableReference methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitTableReference: self.! !

!MATableReference methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:32'!
cellCount
	^ self columnCount * self rowCount.! !

!MATableReference methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:32'!
columnCount
	^ self columnLabels size.! !

!MATableReference methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
columnLabels
	columnLabels isNil 
		ifTrue: [ self columnLabels: self class defaultColumnLabels ].
	^ columnLabels.! !

!MATableReference methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
columnLabels: aCollection
	columnLabels := aCollection! !

!MATableReference methodsFor: 'accessing-conveniance' stamp: 'lr 5/8/2005 20:32'!
columnLabelsTextual
	^ self collectionToString: self columnLabels.! !

!MATableReference methodsFor: 'accessing-conveniance' stamp: 'lr 5/8/2005 20:32'!
columnLabelsTextual: aString
	^ self columnLabels: (self stringToCollection: aString default: self class defaultColumnLabels).! !

!MATableReference methodsFor: 'accessing-indexes' stamp: 'lr 5/8/2005 20:32'!
columnOfIndex: anInteger
	| index |
	index := anInteger \\ self columnCount.
	^ index isZero
		ifTrue: [ self columnCount ]
		ifFalse: [ index ].! !

!MATableReference methodsFor: 'accessing-indexes' stamp: 'lr 5/8/2005 20:32'!
indexAt: aRowIndex at: aColIndex 
	^ ((aRowIndex - 1) * self columnCount) + aColIndex.! !

!MATableReference methodsFor: 'testing' stamp: 'lr 5/8/2005 20:32'!
isSatisfiedBy: anObject
	^ (super isSatisfiedBy: anObject)
		and: [ self cellCount = anObject size ].! !

!MATableReference methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:32'!
kind
	^ SequenceableCollection! !

!MATableReference methodsFor: 'copying' stamp: 'lr 5/8/2005 20:32'!
postCopy
	super postCopy.
	self rowLabels: self rowLabels copy.
	self columnLabels: self columnLabels copy.
	self cellDescription: self cellDescription copy.! !

!MATableReference methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:32'!
rowCount
	^ self rowLabels size.! !

!MATableReference methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
rowLabels
	rowLabels isNil 
		ifTrue: [ self rowLabels: self class defaultRowLables ].
	^ rowLabels.! !

!MATableReference methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
rowLabels: aCollection
	rowLabels := aCollection! !

!MATableReference methodsFor: 'accessing-conveniance' stamp: 'lr 5/8/2005 20:32'!
rowLabelsTextual
	^ self collectionToString: self rowLabels.! !

!MATableReference methodsFor: 'accessing-conveniance' stamp: 'lr 5/8/2005 20:32'!
rowLabelsTextual: aString
	^ self rowLabels: (self stringToCollection: aString default: self class defaultRowLables).! !

!MATableReference methodsFor: 'accessing-indexes' stamp: 'lr 5/8/2005 20:32'!
rowOfIndex: anInteger
	^ anInteger - 1 // self columnCount + 1.! !

MAReferenceDescription subclass: #MATokenDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATokenDescription class methodsFor: 'converting' stamp: 'lr 8/13/2005 11:51'!
asLabel
	^ 'Token Field'! !

!MATokenDescription class methodsFor: 'testing' stamp: 'lr 8/11/2005 09:32'!
isAbstract
	^ false! !

!MATokenDescription methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitTokenDescription: self.! !

!MATokenDescription methodsFor: 'accessing' stamp: 'lr 8/13/2005 11:37'!
kind
	^ Array! !

MABasicDescription subclass: #MAStringDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAStringDescription commentStamp: '<historical>' prior: 0!
I'm a very common description used to display strings or ask strings to the user. I provide interface to type one lined strings. Use MATextDescription if you want to allow multiple lines.!

MAStringDescription subclass: #MAPasswordDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAPasswordDescription commentStamp: '<historical>' prior: 0!
I'm basically a string, but when the user type something, stars '*' are printed instead of the characters he entered.!

!MAPasswordDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:33'!
asLabel
	^ 'Password Field'! !

!MAPasswordDescription methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitPasswordDescription: self.! !

!MAPasswordDescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isObfuscated: anObject
	^ anObject notNil
		and: [ anObject isString ] 
		and: [ anObject allSatisfy: [ :each | each = $* ] ].! !

!MAPasswordDescription methodsFor: 'operators' stamp: 'lr 5/8/2005 20:31'!
obfuscated: anObject
	^ String new: (self toString: anObject) size withAll: $*.! !

!MAStringDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:34'!
asLabel
	^ 'Text Field'! !

!MAStringDescription class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:34'!
isAbstract
	^ false! !

!MAStringDescription methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitStringDescription: self.! !

!MAStringDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
kind
	^ String! !

MAStringDescription subclass: #MASymbolDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MASymbolDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:34'!
asLabel
	^ 'Symbol Field'! !

!MASymbolDescription methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitSymbolDescription: self.! !

!MASymbolDescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
kind
	^ Symbol! !

MAStringDescription subclass: #MATextDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATextDescription commentStamp: '<historical>' prior: 0!
I'm a string for multi line input. If you just want to ask the user for just a line of text, use MAStringDescription.!

!MATextDescription class methodsFor: 'converting' stamp: 'lr 5/8/2005 20:34'!
asLabel
	^ 'Memo Field'! !

!MATextDescription methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitTextDescription: self.! !

MADescription subclass: #MAContainer
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAContainer commentStamp: 'lr 5/5/2005 10:12' prior: 0!
A container is a composition of different descriptions, that fully supports the collection protocol.!

!MAContainer class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultAccessor
	^ MAContainerAccessor new.! !

!MAContainer class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultCollection
	^ OrderedCollection new.! !

!MAContainer class methodsFor: 'accessing-description' stamp: 'lr 8/11/2005 17:26'!
descriptionDefault
	^ nil! !

!MAContainer class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MAContainer class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
with: aDescription
	^ self new
		add: aDescription;
		yourself.! !

!MAContainer class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
withAll: aCollection
	^ self new
		addAll: aCollection;
		yourself.! !

!MAContainer methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:30'!
= anObject
	^ super = anObject
		and: [ self children = anObject children ].! !

!MAContainer methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitContainer: self.! !

!MAContainer methodsFor: 'adding' stamp: 'lr 5/8/2005 20:30'!
add: aDescription
	self children add: aDescription.! !

!MAContainer methodsFor: 'adding' stamp: 'lr 5/8/2005 20:30'!
addAll: aCollection
	aCollection do: [ :each | self add: each ].! !

!MAContainer methodsFor: 'converting' stamp: 'lr 5/8/2005 20:30'!
asContainer
	^ self! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
at: anIndex
	^ self children at: anIndex.! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
at: anIndex ifAbsent: aBlock
	^ self children at: anIndex ifAbsent: aBlock.! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
children
	^ children! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
collect: aBlock
	^ self copy 
		setChildren: (self children collect: aBlock);
		yourself.! !

!MAContainer methodsFor: 'copying' stamp: 'lr 9/12/2005 16:23'!
copyEmpty
	^ self copy 
		setChildren: self defaultChildren;
		yourself.! !

!MAContainer methodsFor: 'copying' stamp: 'lr 5/8/2005 20:30'!
copyFrom: aStartIndex to: anEndIndex
	^ self copy 
		setChildren: (self children
			copyFrom: aStartIndex 
			to: anEndIndex);
		yourself.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
detect: aBlock 
	^ self children detect: aBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
detect: aBlock ifNone: anExceptionBlock 
	^ self children detect: aBlock ifNone: anExceptionBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
do: aBlock
	self children do: aBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
do: aBlock separatedBy: aSeparatorBlock
	self children do: aBlock separatedBy: aSeparatorBlock.! !

!MAContainer methodsFor: 'private' stamp: 'lr 9/17/2005 21:45'!
errorCollection: aCollection
	aCollection isEmpty
		ifFalse: [ MAValidationErrors on: self errors: aCollection. ].
	! !

!MAContainer methodsFor: 'private' stamp: 'lr 5/8/2005 20:30'!
errorNotFound: aDescription
	self error: aDescription asLabel , ' not found.'.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
hasChildren
	^ self notEmpty.! !

!MAContainer methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:30'!
hash
	^ super hash bitXor: self children hash.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
includes: aDescription
	^ self children includes: aDescription.! !

!MAContainer methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:30'!
initialize
	super initialize.
	self setChildren: self class defaultCollection.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
inject: anObject into: aBlock 
	^ self children inject: anObject into: aBlock.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isContainer	
	^ true! !

!MAContainer methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isEmpty
	^ self children isEmpty.! !

!MAContainer methodsFor: 'moving' stamp: 'lr 5/8/2005 20:30'!
moveDown: aDescription
	self children moveDown: aDescription.! !

!MAContainer methodsFor: 'moving' stamp: 'lr 5/8/2005 20:30'!
moveUp: aDescription
	self children moveUp: aDescription.! !

!MAContainer methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
notEmpty
	^ self children notEmpty.! !

!MAContainer methodsFor: 'copying' stamp: 'lr 5/8/2005 20:30'!
postCopy
	super postCopy.
	self setChildren: self children copy.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 9/12/2005 16:24'!
reject: aBlock
	^ self copy
		setChildren: (self children reject: aBlock);
		yourself.! !

!MAContainer methodsFor: 'removing' stamp: 'lr 5/8/2005 20:30'!
remove: aDescription
	self children remove: aDescription ifAbsent: [ self errorNotFound: aDescription ].! !

!MAContainer methodsFor: 'removing' stamp: 'lr 9/12/2005 16:25'!
removeAll
	self setChildren: self class defaultCollection.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
select: aBlock
	^ self copy 
		setChildren: (self children select: aBlock);
		yourself.! !

!MAContainer methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:30'!
setChildren: aCollection
	children := aCollection! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
size
	^ self children size.! !

!MAContainer methodsFor: 'validation' stamp: 'lr 9/20/2005 21:46'!
validate: anObject
	| errors |
	errors := Array streamContents: [ :stream |
		self do: [ :each |
			[ each validate: (anObject readUsing: each) ]
				on: MAValidationError 
				do: [ :err | stream nextPut: err ] ] ].
	errors isEmpty
		ifFalse: [ MAMultipleErrors on: self errors: errors ].! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
with: aCollection do: aBlock
	self children with: aCollection do: aBlock.! !

!MAContainer methodsFor: 'enumerating' stamp: 'lr 5/8/2005 20:30'!
withIndexDo: aBlock
	self children withIndexDo: aBlock.! !

MAContainer subclass: #MAPriorityContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAPriorityContainer class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultCollection
	^ SortedCollection new.! !

!MAPriorityContainer methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitPriorityContainer: self.! !

!MAPriorityContainer methodsFor: 'moving' stamp: 'lr 5/8/2005 20:31'!
moveDown: aDescription
	aDescription priority: aDescription priority - 1.
	self resort.! !

!MAPriorityContainer methodsFor: 'moving' stamp: 'lr 5/8/2005 20:31'!
moveUp: aDescription
	aDescription priority: aDescription priority + 1.
	self resort.! !

!MAPriorityContainer methodsFor: 'actions' stamp: 'lr 5/8/2005 20:31'!
resort
	self setChildren: self children copy.! !

!MAPriorityContainer methodsFor: 'initialization' stamp: 'lr 7/7/2005 15:21'!
setChildren: aCollection
	super setChildren: aCollection asSortedCollection.! !

MAContainer subclass: #MAReportContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAReportContainer class methodsFor: 'accessing-defaults-table' stamp: 'lr 5/8/2005 20:33'!
defaultCaption
	^ nil! !

!MAReportContainer class methodsFor: 'accessing-defaults-table' stamp: 'lr 5/8/2005 20:34'!
defaultEmpty
	^ 'The report is empty.'! !

!MAReportContainer class methodsFor: 'accessing-defaults-batch' stamp: 'lr 5/8/2005 20:33'!
defaultPageSize
	^ 10! !

!MAReportContainer class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultShowBatch
	^ true! !

!MAReportContainer class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultShowFooter
	^ false! !

!MAReportContainer class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:34'!
defaultShowHeader
	^ true! !

!MAReportContainer class methodsFor: 'accessing-defaults-table' stamp: 'lr 5/8/2005 20:34'!
defaultSummary
	^ nil! !

!MAReportContainer class methodsFor: 'accessing-description-table' stamp: 'lr 5/8/2005 20:33'!
descriptionCaption
	^ MAStringDescription selector: #caption label: 'Caption' priority: 1000 default: self defaultCaption.! !

!MAReportContainer class methodsFor: 'accessing-description-table' stamp: 'lr 5/8/2005 20:34'!
descriptionEmpty
	^ MAStringDescription selector: #empty label: 'Empty' priority: 1200 default: self defaultEmpty.! !

!MAReportContainer class methodsFor: 'accessing-description-batch' stamp: 'lr 5/8/2005 20:34'!
descriptionPageSize
	^ MANumberDescription selector: #pageSize label: 'Page Size' priority: 2000 default: self defaultPageSize.! !

!MAReportContainer class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionShowBatch
	^ MABooleanDescription selector: #showBatch label: 'Show Batch' priority: 3200 default: self defaultShowBatch.! !

!MAReportContainer class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionShowFooter
	^ MABooleanDescription selector: #showFooter label: 'Show Footer' priority: 3100 default: self defaultShowFooter.! !

!MAReportContainer class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:34'!
descriptionShowHeader
	^ MABooleanDescription selector: #showHeader label: 'Show Header' priority: 3000 default: self defaultShowHeader.! !

!MAReportContainer class methodsFor: 'accessing-description-table' stamp: 'lr 5/8/2005 20:34'!
descriptionSummary
	^ MAStringDescription selector: #summary label: 'Summary' priority: 1100 default: self defaultSummary.! !

!MAReportContainer methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitReportContainer: self.! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 5/8/2005 20:32'!
caption
	^ self propertyAt: #caption ifAbsent: [ self class defaultCaption ].! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 5/8/2005 20:32'!
caption: aString
	self propertyAt: #caption put: aString.! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 5/8/2005 20:32'!
empty
	^ self propertyAt: #empty ifAbsent: [ self class defaultEmpty ].! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 5/8/2005 20:32'!
empty: aString
	self propertyAt: #empty put: aString.! !

!MAReportContainer methodsFor: 'accessing-batch' stamp: 'lr 5/8/2005 20:32'!
pageSize
	^ self propertyAt: #pageSize ifAbsent: [ self class defaultPageSize ].! !

!MAReportContainer methodsFor: 'accessing-batch' stamp: 'lr 5/8/2005 20:32'!
pageSize: aNumber
	self propertyAt: #pageSize put: aNumber.! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
showBatch
	^ self propertyAt: #showBatch ifAbsent: [ self class defaultShowBatch ].! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
showBatch: aBoolean
	self propertyAt: #showBatch put: aBoolean.! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
showFooter
	^ self propertyAt: #showFooter ifAbsent: [ self class defaultShowFooter ].! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
showFooter: aBoolean
	self propertyAt: #showFooter put: aBoolean.! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
showHeader
	^ self propertyAt: #showHeader ifAbsent: [ self class defaultShowHeader ].! !

!MAReportContainer methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
showHeader: aBoolean
	self propertyAt: #showHeader put: aBoolean.! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 5/8/2005 20:32'!
summary
	^ self propertyAt: #summary ifAbsent: [ self class defaultSummary ].! !

!MAReportContainer methodsFor: 'accessing-table' stamp: 'lr 5/8/2005 20:32'!
summary: aString
	self propertyAt: #summary put: aString.! !

!MADescription class methodsFor: 'instance-creation-accessor' stamp: 'lr 5/8/2005 20:33'!
accessor: anAccessor
	^ self accessor: anAccessor label: self defaultLabel.! !

!MADescription class methodsFor: 'instance-creation-accessor' stamp: 'lr 5/8/2005 20:33'!
accessor: anAccessor label: aString
	^ self accessor: anAccessor label: aString priority: self defaultPriority.! !

!MADescription class methodsFor: 'instance-creation-accessor' stamp: 'lr 5/8/2005 20:33'!
accessor: anAccessor label: aString priority: aNumber
	^ self accessor: anAccessor label: aString priority: aNumber default: self defaultDefault.! !

!MADescription class methodsFor: 'instance-creation-accessor' stamp: 'lr 5/8/2005 20:33'!
accessor: anAccessor label: aString priority: aNumber default: anObject
	^ self new
		accessor: anAccessor;
		label: aString;
		priority: aNumber;
		default: anObject;
		yourself.! !

!MADescription class methodsFor: 'instance-creation-auto' stamp: 'lr 6/14/2005 23:37'!
auto: aSelector
	^ self accessor: (MAAutoSelectorAccessor selector: aSelector).! !

!MADescription class methodsFor: 'instance-creation-auto' stamp: 'lr 6/14/2005 23:37'!
auto: aSelector label: aString
	^ self accessor: (MAAutoSelectorAccessor selector: aSelector) label: aString.! !

!MADescription class methodsFor: 'instance-creation-auto' stamp: 'lr 6/14/2005 23:37'!
auto: aSelector label: aString priority: aNumber
	^ self accessor: (MAAutoSelectorAccessor selector: aSelector) label: aString priority: aNumber.! !

!MADescription class methodsFor: 'instance-creation-auto' stamp: 'lr 6/14/2005 23:37'!
auto: aSelector label: aString priority: aNumber default: anObject
	^ self accessor: (MAAutoSelectorAccessor selector: aSelector) label: aString priority: aNumber default: anObject.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 8/25/2005 10:22'!
defaultAccessor
	^ MANullAccessor new.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultComment
	^ nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultCondition
	^ MAConstantRelation true.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultDefault
	^ nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultLabel
	^ nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultPriority
	^ 0! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultReadonly
	^ false! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultRequired
	^ false! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 5/8/2005 20:33'!
defaultVisible
	^ true! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionComment
	^ MATextDescription selector: #comment label: 'Comment' priority: 110 default: self defaultComment.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 9/13/2005 22:18'!
descriptionDefault
	^ self isAbstract 
		ifFalse: [ self selector: #default label: 'Default' priority: 130 default: self defaultDefault ].! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 5/8/2005 20:33'!
descriptionLabel
	^ MAStringDescription selector: #label label: 'Label' priority: 100 default: self defaultLabel.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 9/13/2005 22:08'!
descriptionPriority
	^ (MANumberDescription selector: #priority label: 'Priority' priority: 130 default: self defaultPriority)
		beRequired;
		yourself.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 9/13/2005 23:52'!
descriptionReadonly
	^ MABooleanDescription selector: #readonly label: 'Readonly' priority: 200 default: self defaultReadonly.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 9/13/2005 23:52'!
descriptionRequired
	^ MABooleanDescription selector: #required label: 'Required' priority: 220 default: self defaultRequired.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 9/13/2005 23:52'!
descriptionVisible
	^ MABooleanDescription selector: #visible label: 'Visible' priority: 210 default: self defaultVisible.! !

!MADescription class methodsFor: 'instance-creation-null' stamp: 'lr 7/7/2005 14:24'!
null: anUuid
	^ self accessor: (MANullAccessor uuid: anUuid).! !

!MADescription class methodsFor: 'instance-creation-null' stamp: 'lr 7/7/2005 14:25'!
null: anUuid label: aString
	^ self accessor: (MANullAccessor uuid: anUuid) label: aString.! !

!MADescription class methodsFor: 'instance-creation-null' stamp: 'lr 7/7/2005 14:25'!
null: anUuid label: aString priority: aNumber
	^ self accessor: (MANullAccessor uuid: anUuid) label: aString priority: aNumber.! !

!MADescription class methodsFor: 'instance-creation-null' stamp: 'lr 7/7/2005 14:25'!
null: anUuid label: aString priority: aNumber default: anObject
	^ self accessor: (MANullAccessor uuid: anUuid) label: aString priority: aNumber default: anObject.! !

!MADescription class methodsFor: 'instance-creation-block' stamp: 'lr 5/8/2005 20:33'!
read: aReadBlock write: aWriteBlock
	^ self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock).! !

!MADescription class methodsFor: 'instance-creation-block' stamp: 'lr 5/8/2005 20:33'!
read: aReadBlock write: aWriteBlock label: aString
	^ self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock) label: aString.! !

!MADescription class methodsFor: 'instance-creation-block' stamp: 'lr 5/8/2005 20:33'!
read: aReadBlock write: aWriteBlock label: aString priority: aNumber
	^ self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock) label: aString priority: aNumber.! !

!MADescription class methodsFor: 'instance-creation-block' stamp: 'lr 5/8/2005 20:33'!
read: aReadBlock write: aWriteBlock label: aString priority: aNumber default: anObject
	^ self accessor: (MABlockAccessor read: aReadBlock write: aWriteBlock) label: aString priority: aNumber default: anObject.! !

!MADescription class methodsFor: 'instance-creation-selector' stamp: 'lr 5/8/2005 20:33'!
selector: aSelector
	^ self accessor: (MASelectorAccessor selector: aSelector).! !

!MADescription class methodsFor: 'instance-creation-selector' stamp: 'lr 5/8/2005 20:33'!
selector: aSelector label: aString
	^ self accessor: (MASelectorAccessor selector: aSelector) label: aString.! !

!MADescription class methodsFor: 'instance-creation-selector' stamp: 'lr 5/8/2005 20:33'!
selector: aSelector label: aString priority: aNumber
	^ self accessor: (MASelectorAccessor selector: aSelector) label: aString priority: aNumber.! !

!MADescription class methodsFor: 'instance-creation-selector' stamp: 'lr 5/8/2005 20:33'!
selector: aSelector label: aString priority: aNumber default: anObject
	^ self accessor: (MASelectorAccessor selector: aSelector) label: aString priority: aNumber default: anObject.! !

!MADescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 5/8/2005 20:33'!
selectors: anArray
	^ self accessor: (MACascadeAccessor selectors: anArray).! !

!MADescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 5/8/2005 20:33'!
selectors: anArray label: aString
	^ self accessor: (MACascadeAccessor selectors: anArray) label: aString.! !

!MADescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 5/8/2005 20:33'!
selectors: anArray label: aString priority: aNumber
	^ self accessor: (MACascadeAccessor selectors: anArray) label: aString priority: aNumber.! !

!MADescription class methodsFor: 'instance-creation-cascade' stamp: 'lr 5/8/2005 20:33'!
selectors: anArray label: aString priority: aNumber default: anObject
	^ self accessor: (MACascadeAccessor selectors: anArray) label: aString priority: aNumber default: anObject.! !

!MADescription class methodsFor: 'instance-creation-variable' stamp: 'lr 6/10/2005 16:44'!
variable: aSelector
	^ self accessor: (MAVariableAccessor selector: aSelector).! !

!MADescription class methodsFor: 'instance-creation-variable' stamp: 'lr 6/10/2005 16:44'!
variable: aSelector label: aString
	^ self accessor: (MAVariableAccessor selector: aSelector) label: aString.! !

!MADescription class methodsFor: 'instance-creation-variable' stamp: 'lr 6/10/2005 16:44'!
variable: aSelector label: aString priority: aNumber
	^ self accessor: (MAVariableAccessor selector: aSelector) label: aString priority: aNumber.! !

!MADescription class methodsFor: 'instance-creation-variable' stamp: 'lr 6/10/2005 16:45'!
variable: aSelector label: aString priority: aNumber default: anObject
	^ self accessor: (MAVariableAccessor selector: aSelector) label: aString priority: aNumber default: anObject.! !

!MADescription methodsFor: 'operators' stamp: 'lr 5/8/2005 20:30'!
, aDescription
	"Merge the receiver and aDescription to one composed description"

	^ self asContainer copy
		addAll: aDescription asContainer;
		yourself.! !

!MADescription methodsFor: 'operators' stamp: 'lr 5/8/2005 20:30'!
<= anObject
	"Answer whether the receiver should precede anObject in a priority container."
	
	^ self priority <= anObject priority.! !

!MADescription methodsFor: 'comparing' stamp: 'lr 7/7/2005 14:22'!
= anObject
	^ super = anObject
		and: [ self accessor = anObject accessor ].! !

!MADescription methodsFor: 'visiting' stamp: 'lr 9/13/2005 21:52'!
acceptMagritte: aVisitor
	^ aVisitor visitDescription: self.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 7/7/2005 13:47'!
accessor
	^ accessor ifNil: [ accessor := self class defaultAccessor ].! !

!MADescription methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
accessor: anAccessor	
	accessor := anAccessor! !

!MADescription methodsFor: 'converting' stamp: 'lr 5/8/2005 20:30'!
asContainer
	self subclassResponsibility.! !

!MADescription methodsFor: 'converting' stamp: 'lr 5/8/2005 20:30'!
asLabel
	^ self label ifNil: [ super asLabel ].! !

!MADescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
beHidden
	self visible: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
beOptional
	self required: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
beReadonly
	self readonly: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
beRequired
	self required: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
beVisible
	self visible: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 5/8/2005 20:30'!
beWriteable
	self readonly: false.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
comment	
	^ self propertyAt: #comment ifAbsent: [ self class defaultComment ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
comment: aString
	self propertyAt: #comment put: aString.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
condition	
	^ self propertyAt: #condition ifAbsent: [ self class defaultCondition ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
condition: aCondition
	self propertyAt: #condition put: ((aCondition isKindOf: BlockContext)
		ifTrue: [ MABlockToRelation do: aCondition ]
		ifFalse: [ aCondition ]).! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 7/7/2005 13:37'!
default	
	^ self propertyAt: #default ifAbsent: [ self class defaultDefault ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 7/7/2005 13:37'!
default: anObject
	self propertyAt: #default put: anObject.! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
hasChildren
	^ false! !

!MADescription methodsFor: 'testing' stamp: 'lr 9/15/2005 12:57'!
hasComment
	^ self comment isEmptyOrNil not.! !

!MADescription methodsFor: 'testing' stamp: 'lr 9/15/2005 12:56'!
hasLabel
	^ self label isEmptyOrNil not.! !

!MADescription methodsFor: 'comparing' stamp: 'lr 7/7/2005 14:22'!
hash
	^ super hash bitXor: self accessor hash.! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isContainer	
	^ false! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isDescription
	^ true! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isReadonly
	^ self readonly.! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isRequired
	^ self required.! !

!MADescription methodsFor: 'validation' stamp: 'lr 9/17/2005 16:35'!
isSatisfiedBy: anObject
	" Return true if anObject is a valid instance of the receiver, false otherwise. "
	
	[ self validate: anObject ]
		on: MAValidationError
		do: [ :err | ^ false ].
	^ true.! !

!MADescription methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isVisible
	^ self visible.! !

!MADescription methodsFor: 'accessing-configuration' stamp: 'lr 5/8/2005 20:30'!
kind
	^ Object! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
label	
	^ self propertyAt: #label ifAbsent: [ self class defaultLabel ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
label: aString
	self propertyAt: #label put: aString.! !

!MADescription methodsFor: 'copying' stamp: 'lr 7/7/2005 14:23'!
postCopy
	super postCopy.
	self accessor: self accessor copy.! !

!MADescription methodsFor: 'printing' stamp: 'lr 9/19/2005 19:36'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' label: '; print: self label.
	aStream nextPutAll: ' comment: '; print: self comment.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
priority
	^ self propertyAt: #priority ifAbsent: [ self class defaultPriority ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
priority: aNumber
	self propertyAt: #priority put: aNumber.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
readonly	
	^ self propertyAt: #readonly ifAbsent: [ self class defaultReadonly ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
readonly: aBoolean	
	self propertyAt: #readonly put: aBoolean.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
required	
	^ self propertyAt: #required ifAbsent: [ self class defaultRequired ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
required: aBoolean	
	self propertyAt: #required put: aBoolean.! !

!MADescription methodsFor: 'validation' stamp: 'lr 9/18/2005 20:01'!
validate: anObject
	" Validate anObject in the context of the describing-receiver, raises an error in case of a problem. "
	
	self subclassResponsibility.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
visible	
	^ self propertyAt: #visible ifAbsent: [ self class defaultVisible ].! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 5/8/2005 20:30'!
visible: aBoolean
	self propertyAt: #visible put: aBoolean.! !

MAObject subclass: #MAMemento
	instanceVariableNames: 'model description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Memento'!

MAMemento subclass: #MACachedMemento
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Memento'!

!MACachedMemento class methodsFor: 'testing' stamp: 'lr 9/20/2005 21:00'!
isAbstract
	^ false! !

!MACachedMemento methodsFor: 'accessing' stamp: 'lr 9/20/2005 21:32'!
cache
	^ cache! !

!MACachedMemento methodsFor: 'actions' stamp: 'lr 9/20/2005 20:58'!
commit
	super commit.
	self push: self cache.! !

!MACachedMemento methodsFor: 'testing' stamp: 'lr 9/20/2005 20:56'!
hasChanged
	^ self cache ~= self pull.! !

!MACachedMemento methodsFor: 'private' stamp: 'lr 9/20/2005 20:37'!
readUsing: aDescription
	^ self cache at: aDescription.! !

!MACachedMemento methodsFor: 'actions' stamp: 'lr 9/20/2005 20:58'!
reset
	super reset.
	self setCache: self pull.! !

!MACachedMemento methodsFor: 'initialization' stamp: 'lr 9/20/2005 20:13'!
setCache: aDictionary
	cache := aDictionary! !

!MACachedMemento methodsFor: 'private' stamp: 'lr 9/20/2005 20:08'!
write: anObject using: aDescription
	self cache at: aDescription put: anObject.! !

MACachedMemento subclass: #MACheckedMemento
	instanceVariableNames: 'original'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Memento'!

!MACheckedMemento methodsFor: 'testing' stamp: 'lr 9/20/2005 20:57'!
hasConflict
	^ self hasChanged and: [ self original ~= self pull ].! !

!MACheckedMemento methodsFor: 'accessing' stamp: 'lr 9/20/2005 22:06'!
original
	^ original! !

!MACheckedMemento methodsFor: 'actions' stamp: 'lr 9/20/2005 20:45'!
reset
	super reset.
	self setOriginal: self cache copy.! !

!MACheckedMemento methodsFor: 'initialization' stamp: 'lr 9/20/2005 20:35'!
setOriginal: aDictionary
	original := aDictionary! !

!MAMemento class methodsFor: 'instance creation' stamp: 'lr 9/20/2005 20:03'!
model: aModel
	^ self model: aModel description: aModel description.! !

!MAMemento class methodsFor: 'instance creation' stamp: 'lr 9/20/2005 21:31'!
model: aModel description: aDescription
	^ self new
		setModel: aModel;
		setDescription: aDescription;
		reset;
		yourself.! !

!MAMemento methodsFor: 'actions' stamp: 'lr 9/20/2005 20:09'!
commit
	"Commit the receiver into the model."! !

!MAMemento methodsFor: 'accessing' stamp: 'lr 9/20/2005 19:30'!
description
	^ description! !

!MAMemento methodsFor: 'accessing' stamp: 'lr 9/19/2005 20:00'!
model
	^ model! !

!MAMemento methodsFor: 'printing' stamp: 'lr 9/20/2005 20:36'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' model: '; print: self model.! !

!MAMemento methodsFor: 'private-model' stamp: 'lr 9/20/2005 22:50'!
pull
	| result value |
	result := Dictionary new.
	self description do: [ :each |
		value := (self model readUsing: each)
			ifNil: [ each default ].
		result at: each put: value ].
	^ result.! !

!MAMemento methodsFor: 'private-model' stamp: 'lr 9/20/2005 22:49'!
push: aDictionary
	aDictionary keysAndValuesDo: [ :key :value |
		self model 
			write: value 
			using: key ].! !

!MAMemento methodsFor: 'private' stamp: 'lr 9/20/2005 20:04'!
readUsing: aDescription
	self subclassResponsibility.! !

!MAMemento methodsFor: 'actions' stamp: 'lr 9/20/2005 20:36'!
reset
	"Reset the memento from the model."! !

!MAMemento methodsFor: 'initialization' stamp: 'lr 9/19/2005 21:09'!
setDescription: aDescription
	description := aDescription! !

!MAMemento methodsFor: 'initialization' stamp: 'lr 9/19/2005 20:12'!
setModel: aModel
	model := aModel! !

!MAMemento methodsFor: 'actions' stamp: 'lr 9/20/2005 20:38'!
validate
	"Check if the value is valid within the model. In case of problems an exception is raised."
	
	self description validate: self.! !

!MAMemento methodsFor: 'private' stamp: 'lr 9/20/2005 20:04'!
write: anObject using: aDescription
	self subclassResponsibility.! !

MAMemento subclass: #MAStraitMemento
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Memento'!

!MAStraitMemento class methodsFor: 'testing' stamp: 'lr 9/20/2005 21:00'!
isAbstract
	^ false! !

!MAStraitMemento methodsFor: 'private' stamp: 'lr 9/20/2005 22:50'!
readUsing: aDescription
	^ (self model readUsing: aDescription)
		ifNil: [ aDescription default ].! !

!MAStraitMemento methodsFor: 'private' stamp: 'lr 9/20/2005 21:49'!
write: anObject using: aDescription
	self model write: anObject using: aDescription.! !

MAObject subclass: #MAMementoOld
	instanceVariableNames: 'model description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Memento'!

MAMementoOld subclass: #MACachedMementoOld
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Memento'!

!MACachedMementoOld class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MACachedMementoOld methodsFor: 'actions' stamp: 'lr 9/19/2005 19:44'!
commit
	super commit.
	self push: self value.! !

!MACachedMementoOld methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
hasChanged
	^ self pull ~= self value.! !

!MACachedMementoOld methodsFor: 'actions' stamp: 'lr 9/19/2005 19:46'!
reset
	super reset.
	self value: (self pull ifNil: [ self description default ]).! !

!MACachedMementoOld methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:29'!
setModel: aModel
	super setModel: aModel.
	self reset.! !

!MACachedMementoOld methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
value
	^ value! !

!MACachedMementoOld methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
value: anObject
	value := anObject! !

MACachedMementoOld subclass: #MACheckedMementoOld
	instanceVariableNames: 'original'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Memento'!

!MACheckedMementoOld methodsFor: 'actions' stamp: 'lr 9/19/2005 19:43'!
commit
	super commit.
	self original: self value.! !

!MACheckedMementoOld methodsFor: 'testing' stamp: 'lr 5/8/2005 20:29'!
hasConflict
	^ self hasChanged
		and: [ self pull ~= self original ].! !

!MACheckedMementoOld methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
original
	^ original! !

!MACheckedMementoOld methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
original: anObject
	original := anObject! !

!MACheckedMementoOld methodsFor: 'printing' stamp: 'lr 5/8/2005 20:29'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' original: '; print: self original.! !

!MACheckedMementoOld methodsFor: 'actions' stamp: 'lr 9/19/2005 19:46'!
reset
	super reset.
	self original: self pull.! !

!MACheckedMementoOld methodsFor: 'actions' stamp: 'lr 9/19/2005 19:50'!
validate
	super validate.
	self hasConflict 
		ifTrue: [ self reset; errorConcurrent ].! !

!MAMementoOld class methodsFor: 'instance creation' stamp: 'lr 5/9/2005 13:33'!
on: aDescription model: aModel
	^ self new
		setDescription: aDescription;
		setModel: aModel;
		yourself.! !

!MAMementoOld methodsFor: 'comparing' stamp: 'lr 7/7/2005 13:28'!
= anObject
	^ super = anObject
		and: [ self model = anObject model ].! !

!MAMementoOld methodsFor: 'accessing' stamp: 'lr 5/9/2005 13:30'!
accessor
	^ self description accessor.! !

!MAMementoOld methodsFor: 'actions' stamp: 'lr 9/19/2005 19:44'!
commit
	"Commit the value into the model."! !

!MAMementoOld methodsFor: 'accessing' stamp: 'lr 5/9/2005 13:30'!
description
	^ description! !

!MAMementoOld methodsFor: 'errors' stamp: 'lr 5/9/2005 13:31'!
errorConcurrent
	MAConcurrentError memento: self message: 'Concurrent modification in ' , self description asLabel.! !

!MAMementoOld methodsFor: 'errors' stamp: 'lr 5/9/2005 13:31'!
errorReadonly
	MAReadonlyError memento: self message: self description asLabel , ' is readonly.'.! !

!MAMementoOld methodsFor: 'errors' stamp: 'lr 5/9/2005 13:31'!
errorRequired
	MARequiredError memento: self message: self description asLabel , ' is required.'.! !

!MAMementoOld methodsFor: 'errors' stamp: 'lr 5/9/2005 13:31'!
errorValidation
	MAValidationError memento: self message: self description asLabel , ' is invalid.'.! !

!MAMementoOld methodsFor: 'comparing' stamp: 'lr 7/7/2005 13:28'!
hash
	^ super hash bitXor: self model hash.! !

!MAMementoOld methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
model
	^ model! !

!MAMementoOld methodsFor: 'copying' stamp: 'lr 5/9/2005 13:33'!
postCopy
	super postCopy.
	self setDescription: nil.! !

!MAMementoOld methodsFor: 'printing' stamp: 'lr 5/8/2005 20:31'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' value: '; print: self value.! !

!MAMementoOld methodsFor: 'private-model' stamp: 'lr 5/9/2005 13:31'!
pull
	"Primitive to read from the model. Do not call directly, use #value instead."

	^ self model readUsing: self description.! !

!MAMementoOld methodsFor: 'private-model' stamp: 'lr 5/9/2005 13:31'!
push: anObject
	"Primitive to write to the model. Do not call directly, use #value: instead."

	self model write: anObject using: self description.! !

!MAMementoOld methodsFor: 'actions' stamp: 'lr 9/19/2005 19:44'!
reset
	"Reset the value to the one of the model."! !

!MAMementoOld methodsFor: 'initialization' stamp: 'lr 5/9/2005 13:32'!
setDescription: aDescription
	description := aDescription! !

!MAMementoOld methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:31'!
setModel: aModel
	model := aModel! !

!MAMementoOld methodsFor: 'actions' stamp: 'lr 9/19/2005 19:48'!
validate
	"Check if the value is valid within the model. In case of problems an exception is raised."
	
	(self description isRequired and: [ self value isNil ])
		ifTrue: [ self errorRequired ].
	(self value isNil or: [ self description isSatisfiedBy: self value ])
		ifFalse: [ self errorValidation ].! !

!MAMementoOld methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:31'!
value
	self subclassResponsibility.! !

!MAMementoOld methodsFor: 'accessing-dynamic' stamp: 'lr 5/8/2005 20:31'!
value: anObject
	self subclassResponsibility.! !

MAMementoOld subclass: #MAStraitMementoOld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Memento'!

!MAStraitMementoOld class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:34'!
isAbstract
	^ false! !

!MAStraitMementoOld methodsFor: 'accessing' stamp: 'lr 5/9/2005 13:51'!
value
	^ self pull ifNil: [ self description default ].! !

!MAStraitMementoOld methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
value: anObject
	self push: anObject.! !

!MAObject class methodsFor: 'converting' stamp: 'lr 6/10/2005 16:47'!
asLabel
	^ super asLabel allButFirst: 2.! !

!MAObject class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ true! !

!MAObject class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
new
	"Create a new instance of the receiving class and checks if it is concrete."

	self isAbstract
		ifTrue: [ self error: self name , ' is abstract.' ].
	^ super new.! !

!MAObject class methodsFor: 'reflection' stamp: 'dc 8/15/2005 16:34'!
withAllConcreteClasses
	^ Array streamContents: [ :stream |
		self withAllConcreteClassesDo: [ :each |
			stream nextPut: each ] ].! !

!MAObject class methodsFor: 'reflection' stamp: 'dc 8/15/2005 16:33'!
withAllConcreteClassesDo: aBlock
	self withAllSubclassesDo: [ :each |
		each isAbstract ifFalse: [ 
			aBlock value: each ] ].! !

!MAObject methodsFor: 'comparing' stamp: 'lr 7/7/2005 13:25'!
= anObject
	^ self species = anObject species.! !

!MAObject methodsFor: 'visiting' stamp: 'lr 5/8/2005 20:31'!
acceptMagritte: aVisitor! !

!MAObject methodsFor: 'private' stamp: 'lr 5/8/2005 20:31'!
errorPropertyNotFound: aSelector
	self error: 'Property ' , aSelector , ' not found.'! !

!MAObject methodsFor: 'testing' stamp: 'lr 7/7/2005 14:39'!
hasProperty: aKey
	^ self properties includesKey: aKey.! !

!MAObject methodsFor: 'comparing' stamp: 'lr 7/7/2005 13:26'!
hash
	^ self species hash.! !

!MAObject methodsFor: 'copying' stamp: 'lr 5/8/2005 20:31'!
postCopy
	super postCopy.
	properties := properties copy.! !

!MAObject methodsFor: 'accessing' stamp: 'lr 7/7/2005 13:23'!
properties
	^ properties ifNil: [ properties := Dictionary new ].! !

!MAObject methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
propertyAt: aKey
	^ self propertyAt: aKey ifAbsent: [ self errorPropertyNotFound: aKey ].! !

!MAObject methodsFor: 'accessing' stamp: 'lr 7/7/2005 13:23'!
propertyAt: aKey ifAbsent: aBlock
	^ self properties at: aKey ifAbsent: aBlock.! !

!MAObject methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
propertyAt: aKey ifAbsentPut: aBlock
	^ self properties at: aKey ifAbsentPut: aBlock.! !

!MAObject methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
propertyAt: aKey put: aValue
	^ self properties at: aKey put: aValue.! !

MAObject subclass: #MARelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MARelation commentStamp: '<historical>' prior: 0!
I represent an immutable relation. Users usually want to check if the relation I am representing is satisfied by sending the message #isSatisfiedBy:!

MARelation subclass: #MABasicRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

MABasicRelation subclass: #MAConstantRelation
	instanceVariableNames: 'value'
	classVariableNames: 'FalseRelation TrueRelation'
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MAConstantRelation class methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:33'!
false
	^ FalseRelation! !

!MAConstantRelation class methodsFor: 'class initialization' stamp: 'lr 5/8/2005 20:33'!
initialize
	TrueRelation := self new
		setValue: true;
		yourself.
	FalseRelation := self new
		setValue: false;
		yourself.! !

!MAConstantRelation class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MAConstantRelation class methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:33'!
true
	^ TrueRelation! !

!MAConstantRelation methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:30'!
= anObject
	^ super = anObject
		and: [ self value = anObject value ].! !

!MAConstantRelation methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:30'!
hash
	^ super hash bitXor: self value hash.! !

!MAConstantRelation methodsFor: 'testing' stamp: 'lr 5/8/2005 20:30'!
isSatisfiedBy: anObject
	^ self value.! !

!MAConstantRelation methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:30'!
setValue: aBoolean
	value := aBoolean! !

!MAConstantRelation methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
value
	^ value! !

MABasicRelation subclass: #MASelectorRelation
	instanceVariableNames: 'selector arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

MASelectorRelation subclass: #MAAccessorRelation
	instanceVariableNames: 'accessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MAAccessorRelation methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:29'!
accessor
	^ accessor! !

!MAAccessorRelation methodsFor: 'testing' stamp: 'lr 8/10/2005 21:15'!
isSatisfiedBy: anObject
	| description |
	description := anObject description
		detect: [ :each | self accessor = each accessor ]
		ifNone: [ ^ false ].
	^ super isSatisfiedBy: (description accessor read: anObject).! !

!MAAccessorRelation methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:29'!
setAccessor: anAccessor
	accessor := anAccessor! !

MASelectorRelation subclass: #MAQueryRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MAQueryRelation methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isSatisfiedBy: anObject
	^ super isSatisfiedBy: anObject query.! !

!MASelectorRelation class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:34'!
isAbstract
	^ false! !

!MASelectorRelation class methodsFor: 'conveniance' stamp: 'lr 5/8/2005 20:34'!
selector: aSelector
	^ self selector: aSelector arguments: Array new.! !

!MASelectorRelation class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:34'!
selector: aSelector arguments: aCollection
	^ self new
		setSelector: aSelector;
		setArguments: aCollection;
		yourself.! !

!MASelectorRelation class methodsFor: 'conveniance' stamp: 'lr 5/8/2005 20:34'!
selector: aSelector with: anObject
	^ self selector: aSelector arguments: (Array with: anObject).! !

!MASelectorRelation class methodsFor: 'conveniance' stamp: 'lr 5/8/2005 20:34'!
selector: aSelector with: aFirstObject with: aSecondObject
	^ self selector: aSelector arguments: (Array with: aFirstObject with: aSecondObject).! !

!MASelectorRelation methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
arguments
	^ arguments! !

!MASelectorRelation methodsFor: 'testing' stamp: 'lr 5/8/2005 20:32'!
isSatisfiedBy: anObject
	^ anObject perform: self selector withArguments: self arguments.! !

!MASelectorRelation methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:32'!
selector
	^ selector! !

!MASelectorRelation methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:32'!
setArguments: aCollection
	arguments := aCollection! !

!MASelectorRelation methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:32'!
setSelector: aSelector
	selector := aSelector! !

!MASelectorRelation methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:32'!
setSelector: aSelector argument: anObject
	self setSelector: (self selector , aSelector) asSymbol.
	self setArguments: (self arguments copyWith: anObject).! !

MARelation subclass: #MAComposedRelation
	instanceVariableNames: 'relations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

MAComposedRelation subclass: #MAAllRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MAAllRelation class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MAAllRelation methodsFor: 'operators' stamp: 'lr 5/8/2005 20:29'!
& aRelation
	^ self copyWith: aRelation.! !

!MAAllRelation methodsFor: 'testing' stamp: 'lr 7/7/2005 13:30'!
isSatisfiedBy: anObject
	^ self relations allSatisfy: [ :each | each isSatisfiedBy: anObject ].! !

MAComposedRelation subclass: #MAAnyRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MAAnyRelation class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MAAnyRelation methodsFor: 'testing' stamp: 'lr 7/7/2005 13:30'!
isSatisfiedBy: anObject
	^ self relations anySatisfy: [ :each | each isSatisfiedBy: anObject ].! !

!MAAnyRelation methodsFor: 'operators' stamp: 'lr 5/8/2005 20:29'!
| aRelation
	^ self copyWith: aRelation.! !

!MAComposedRelation class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
new
	^ super new
		setRelations: Array new;
		yourself.! !

!MAComposedRelation class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
with: aRelation
	^ self withAll: (Array with: aRelation).! !

!MAComposedRelation class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
with: aFirstRelation with: aSecondRelation
	^ self withAll: (Array with: aFirstRelation with: aSecondRelation).! !

!MAComposedRelation class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
withAll: anArray
	^ self new
		setRelations: anArray;
		yourself.! !

!MAComposedRelation methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:30'!
= anObject
	^ super = anObject
		and: [ self relations = anObject relations ].! !

!MAComposedRelation methodsFor: 'copying' stamp: 'lr 5/8/2005 20:30'!
copyWith: aRelation
	^ self class withAll: (self relations copyWith: aRelation).! !

!MAComposedRelation methodsFor: 'comparing' stamp: 'lr 5/8/2005 20:30'!
hash
	^ super hash bitXor: self relations.! !

!MAComposedRelation methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:30'!
relations
	^ relations! !

!MAComposedRelation methodsFor: 'initialization' stamp: 'lr 5/8/2005 20:30'!
setRelations: aCollection
	relations := aCollection! !

MAComposedRelation subclass: #MANoneRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MANoneRelation class methodsFor: 'testing' stamp: 'lr 5/8/2005 20:33'!
isAbstract
	^ false! !

!MANoneRelation methodsFor: 'operators' stamp: 'lr 7/8/2005 11:01'!
!! aRelation
	^ self copyWith: aRelation.! !

!MANoneRelation methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isSatisfiedBy: anObject
	^ self relations noneSatisfy: [ :each | 
		each isSatisfiedBy: anObject ].! !

!MARelation methodsFor: 'operators-binary' stamp: 'lr 7/8/2005 11:01'!
!! aRelation
	^ MANoneRelation with: self with: aRelation.! !

!MARelation methodsFor: 'operators-binary' stamp: 'lr 5/8/2005 20:31'!
& aRelation
	^ MAAllRelation with: self with: aRelation.! !

!MARelation methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isSatisfiedBy: anObject
	self subclassResponsibility.! !

!MARelation methodsFor: 'operators-unary' stamp: 'lr 5/8/2005 20:31'!
not
	^ MANoneRelation with: self.! !

!MARelation methodsFor: 'operators-binary' stamp: 'lr 5/8/2005 20:31'!
| aRelation
	^ MAAnyRelation with: self with: aRelation.! !

Object subclass: #MAScaffolder
	instanceVariableNames: 'description values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Model'!

!MAScaffolder class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:34'!
description: aDescription
	^ self new
		description: aDescription;
		yourself.! !

!MAScaffolder methodsFor: 'accessing-configuration' stamp: 'lr 8/11/2005 13:13'!
defaultDescription
	^ MAContainer new.! !

!MAScaffolder methodsFor: 'accessing-configuration' stamp: 'lr 8/11/2005 13:13'!
defaultDictionary
	^ Dictionary new.! !

!MAScaffolder methodsFor: 'accessing' stamp: 'lr 8/11/2005 13:11'!
description
	^ description! !

!MAScaffolder methodsFor: 'accessing' stamp: 'lr 8/11/2005 13:12'!
description: aDescription
	description := aDescription! !

!MAScaffolder methodsFor: 'initialization' stamp: 'lr 8/11/2005 13:19'!
initialize
	super initialize.
	self description: self defaultDescription.
	self values: self defaultDictionary.! !

!MAScaffolder methodsFor: 'model' stamp: 'lr 8/11/2005 17:32'!
readUsing: aDescription
	^ aDescription isContainer
		ifFalse: [ self values at: aDescription ifAbsent: [ aDescription default ] ]
		ifTrue: [ super readUsing: aDescription ].! !

!MAScaffolder methodsFor: 'accessing' stamp: 'lr 8/11/2005 13:18'!
values
	^ values! !

!MAScaffolder methodsFor: 'accessing' stamp: 'lr 8/11/2005 13:18'!
values: aDictionary
	values := aDictionary! !

!MAScaffolder methodsFor: 'model' stamp: 'lr 8/11/2005 17:33'!
write: anObject using: aDescription
	 aDescription isContainer
		ifFalse: [ self values at: aDescription put: anObject ]
		ifTrue: [ super write: anObject using: aDescription ].! !

Object subclass: #MAVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Visitor'!

!MAVisitor commentStamp: 'lr 9/12/2005 12:14' prior: 0!
I am a visitor responsible to visit Magritte descriptions. I am an abstract calss providing a default implementation for concrete visitors. The protocol I am implementing reflects the hierarchy of MADescription with its subclasses so that visiting a specific class automatically calls less specific implementations in case the specific implementation has been left out. This code was automatically using #buildVisitorHierarchyForClass:selector:classified: on my class-side.!

MAVisitor subclass: #MAFormatter
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Visitor'!

!MAFormatter class methodsFor: 'instance creation' stamp: 'lr 9/12/2005 11:15'!
format: anObject description: aDescription
	^ self new format: anObject description: aDescription.! !

!MAFormatter methodsFor: 'visiting' stamp: 'lr 9/15/2005 10:59'!
format: anObject description: aDescription
	anObject isNil ifTrue: [ ^ aDescription undefined ].
	^ self object: anObject; visit: aDescription.! !

!MAFormatter methodsFor: 'private' stamp: 'lr 9/12/2005 16:48'!
formatError
	MAFormatError signal: 'Unable to format ' , self object , '.'.! !

!MAFormatter methodsFor: 'accessing' stamp: 'lr 9/12/2005 11:18'!
object
	^ object! !

!MAFormatter methodsFor: 'accessing' stamp: 'lr 9/12/2005 11:18'!
object: anObject
	object := anObject! !

!MAFormatter methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 22:34'!
visitBasicDescription: aDescription
	^ self object asString.! !

!MAFormatter methodsFor: 'visiting-description' stamp: 'lr 9/12/2005 16:48'!
visitBooleanDescription: aDescription
	self object
		ifTrue: [ ^ aDescription trueStrings first ].
	self object
		ifFalse: [ ^ aDescription falseStrings first ].
	self formatError.! !

!MAFormatter methodsFor: 'visiting-description' stamp: 'lr 9/12/2005 17:05'!
visitClassDescription: aDescription
	^ self object name.! !

!MAFormatter methodsFor: 'visiting-description' stamp: 'lr 9/12/2005 11:59'!
visitColorDescription: aDescription
	^ String streamContents: [ :stream |
		stream nextPut: $#.
		stream nextPutAll: ((self object red * 255) asInteger
			printPaddedWith: $0 to: 2 base: 16).
		stream nextPutAll: ((self object green * 255) asInteger
			printPaddedWith: $0 to: 2 base: 16).
		stream nextPutAll: ((self object blue * 255) asInteger
			printPaddedWith: $0 to: 2 base: 16) ].! !

!MAFormatter methodsFor: 'visiting-description' stamp: 'lr 9/12/2005 12:01'!
visitTimeDescription: aDescription
	^ self object print24.! !

!MAFormatter methodsFor: 'visiting-description' stamp: 'lr 9/15/2005 11:45'!
visitTimeStampDescription: aDescription
	^ String streamContents: [ :stream |
		stream print: self object asDate; space; nextPutAll: self object asTime print24 ].! !

!MAFormatter methodsFor: 'visiting-description' stamp: 'lr 9/15/2005 11:52'!
visitTokenDescription: aDescription
	^ String streamContents: [ :stream |
		self object
			do: [ :each | stream nextPutAll: (aDescription reference toString: each) ]
			separatedBy: [ stream nextPutAll: ' '  ] ].! !

MAVisitor subclass: #MAParser
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Visitor'!

!MAParser class methodsFor: 'instance creation' stamp: 'lr 9/12/2005 11:17'!
parse: aString description: aDescription
	^ self new parse: aString description: aDescription.! !

!MAParser methodsFor: 'visiting' stamp: 'lr 9/14/2005 22:50'!
parse: aString description: aDescription
	aString isEmptyOrNil ifTrue: [ ^ nil ].
	^ self string: aString; visit: aDescription.! !

!MAParser methodsFor: 'accessing' stamp: 'lr 9/12/2005 11:17'!
string
	^ string! !

!MAParser methodsFor: 'accessing' stamp: 'lr 9/12/2005 11:17'!
string: aString
	string := aString! !

!MAParser methodsFor: 'private' stamp: 'lr 9/13/2005 23:47'!
unableToParse
	MAParseError signal: 'Unable to parse ' , self string asString , '.'.! !

!MAParser methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 22:58'!
visitBasicDescription: aDescription
	^ aDescription kind fromString: self string.! !

!MAParser methodsFor: 'visiting-description' stamp: 'lr 9/14/2005 22:51'!
visitBooleanDescription: aDescription
	(aDescription trueStrings includes: self string)
		ifTrue: [ ^ true ].
	(aDescription falseStrings includes: self string)
		ifTrue: [ ^ false ].
	^ self unableToParse.! !

!MAParser methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 23:48'!
visitClassDescription: aDescription
	^ MACompatibility classNamed: self string ifAbsent: [ self unableToParse ].! !

!MAParser methodsFor: 'visiting-description' stamp: 'lr 9/15/2005 12:01'!
visitFileDescription: aDescription
	^ MACompatibility mimeDecode: self string.! !

!MAParser methodsFor: 'visiting-description' stamp: 'lr 9/14/2005 22:56'!
visitMagnitudeDescription: aDescription
	^ aDescription kind readFrom: self string readStream.! !

!MAParser methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 22:59'!
visitStringDescription: aDescription
	^ self string.! !

!MAParser methodsFor: 'visiting-description' stamp: 'lr 9/15/2005 11:53'!
visitSymbolDescription: aDescription
	^ self string asSymbol.! !

!MAParser methodsFor: 'visiting-description' stamp: 'lr 9/15/2005 11:54'!
visitTokenDescription: aDescription
	| token |
	token := aDescription kind withAll: (self string findTokens: ' ').
	^ token collect: [ :each | aDescription reference fromString: each ].! !

!MAVisitor class methodsFor: 'private' stamp: 'lr 9/9/2005 12:17'!
buildVisitorHierarchyForClass: aClass selector: aBlock classified: aSelector
	" self buildVisitorHierarchyForClass: MADescription selector: [ :class | 'visit' , (class name allButFirst: 2) , ':' ] classified: #'visiting-description' "
	
	aClass withAllSubclassesDo: [ :class |
		(class category beginsWith: 'Magritte') ifTrue: [
			self
				compile: (String streamContents: [ :stream |
					stream nextPutAll: (aBlock value: class); nextPutAll: ' anObject'; cr.
					class = aClass ifFalse: [ 
						stream tab; nextPutAll: '^ self '; nextPutAll: (aBlock value: class superclass); nextPutAll: ' anObject.' ] ])
				classified: aSelector.
			class
				compile: (String streamContents: [ :stream |
					stream nextPutAll: 'acceptMagritte: aVisitor'; cr.
					stream tab; nextPutAll: '^ aVisitor '; nextPutAll: (aBlock value: class); nextPutAll: ' self.' ])
				classified: #visiting ] ]! !

!MAVisitor methodsFor: 'visiting' stamp: 'lr 9/9/2005 12:17'!
visit: anObject
	^ anObject acceptMagritte: self.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitBasicDescription: anObject
	^ self visitDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitBooleanDescription: anObject
	^ self visitBasicDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitClassDescription: anObject
	^ self visitBasicDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitColorDescription: anObject
	^ self visitBasicDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitContainer: anObject
	^ self visitDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitDateDescription: anObject
	^ self visitMagnitudeDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitDescription: anObject
! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitDurationDescription: anObject
	^ self visitMagnitudeDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/9/2005 12:17'!
visitElementDescription: anObject
	^ self visitDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitFileDescription: anObject
	^ self visitBasicDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitMagnitudeDescription: anObject
	^ self visitBasicDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitMultipleOptionDescription: anObject
	^ self visitOptionDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/12/2005 16:53'!
visitMultipleReference: anObject
	^ self visitSelectionReference: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitNumberDescription: anObject
	^ self visitMagnitudeDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitOptionDescription: anObject
	^ self visitReference: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitPasswordDescription: anObject
	^ self visitStringDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitPriorityContainer: anObject
	^ self visitContainer: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitReference: anObject
	^ self visitBasicDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitReportContainer: anObject
	^ self visitContainer: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/12/2005 16:53'!
visitSelectionReference: anObject
	^ self visitReference: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitSingleOptionDescription: anObject
	^ self visitOptionDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/12/2005 16:53'!
visitSingleReference: anObject
	^ self visitSelectionReference: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitStringDescription: anObject
	^ self visitBasicDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitSymbolDescription: anObject
	^ self visitStringDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitTableReference: anObject
	^ self visitReference: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitTextDescription: anObject
	^ self visitStringDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitTimeDescription: anObject
	^ self visitMagnitudeDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitTimeStampDescription: anObject
	^ self visitMagnitudeDescription: anObject.! !

!MAVisitor methodsFor: 'visiting-description' stamp: 'lr 9/13/2005 21:52'!
visitTokenDescription: anObject
	^ self visitBasicDescription: anObject.! !

!Object class methodsFor: '*Magritte-Core-converting' stamp: 'lr 5/8/2005 20:29'!
asLabel
	^ self name! !

!Object class methodsFor: '*Magritte-Core-accessing' stamp: 'lr 5/8/2005 20:29'!
description
	^ MACachedBuilder default build: self.! !

!Object methodsFor: '*Magritte-Core-converting' stamp: 'lr 5/8/2005 20:29'!
asLabel
	^ self asString.! !

!Object methodsFor: '*Magritte-Core-defaults' stamp: 'lr 5/8/2005 20:29'!
defaultContainer
	"Return the default description container."
	
	^ MAPriorityContainer new 
		label: self asLabel;
		yourself.! !

!Object methodsFor: '*Magritte-Core-defaults' stamp: 'lr 5/8/2005 20:29'!
defaultWrapperClass
	^ MACheckedMemento! !

!Object methodsFor: '*Magritte-Core-accessing' stamp: 'lr 5/8/2005 20:29'!
description
	"Return the description of the reciever. Subclasses might override this message to return instance-based descriptions."
	
	^ self class description.! !

!Object methodsFor: '*Magritte-Core-testing' stamp: 'lr 5/8/2005 20:29'!
isDescription
	^ false! !

!Object methodsFor: '*Magritte-Core-accessing' stamp: 'lr 5/8/2005 20:29'!
query
	"Return a string that represents that represents the receiver and is used as a default value for querying."

	^ self asString! !

!Object methodsFor: '*Magritte-Core-model' stamp: 'lr 5/8/2005 20:29'!
readUsing: aDescription
	"Dispatch the read-access to the receiver using the accessor of aDescription."

	^ aDescription accessor read: self.! !

!Object methodsFor: '*Magritte-Core-model' stamp: 'lr 5/8/2005 20:29'!
write: anObject using: aDescription
	"Dispatch the write-access to the receiver of anObject using the accessor of aDescription."

	aDescription accessor write: anObject to: self.! !

!SequenceableCollection methodsFor: '*Magritte-Core-moving' stamp: 'lr 5/8/2005 20:29'!
moveDown: anObject	
	| index |
	index := self 
		indexOf: anObject 
		ifAbsent: [ ^ self ].
	self swap: index with: (index = self size
		ifFalse:[ index + 1 ]
		ifTrue: [ 1 ]).! !

!SequenceableCollection methodsFor: '*Magritte-Core-moving' stamp: 'lr 5/8/2005 20:29'!
moveUp: anObject	
	| index |
	index := self 
		indexOf: anObject 
		ifAbsent: [ ^ self ].
	self swap: index with: (index = 1
		ifFalse:[ index - 1 ]
		ifTrue: [ self size ]).! !

!Color methodsFor: '*Magritte-Core-converting' stamp: 'lr 9/12/2005 12:00'!
asLabel
	^ String streamContents: [ :stream |
		stream nextPut: $#.
		stream nextPutAll: ((self red * 255) asInteger
			printPaddedWith: $0 to: 2 base: 16).
		stream nextPutAll: ((self green * 255) asInteger
			printPaddedWith: $0 to: 2 base: 16).
		stream nextPutAll: ((self blue * 255) asInteger
			printPaddedWith: $0 to: 2 base: 16) ].! !

ProtoObject subclass: #MAProxyObject
	instanceVariableNames: 'realSubject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

MAProxyObject subclass: #MADynamicObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utility'!

!MADynamicObject methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
realSubject
	^ super realSubject value.! !

!MAProxyObject class methodsFor: 'instance creation' stamp: 'lr 5/8/2005 20:33'!
on: anObject
	^ self basicNew realSubject: anObject.! !

!MAProxyObject methodsFor: 'private' stamp: 'lr 5/8/2005 20:31'!
doesNotUnderstand: aMessage
	^ self realSubject
		perform: aMessage selector
		withArguments: aMessage arguments.! !

!MAProxyObject methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isMorph
	^ false! !

!MAProxyObject methodsFor: 'testing' stamp: 'lr 5/8/2005 20:31'!
isNil
	^ self realSubject isNil.! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 5/8/2005 20:31'!
printOn: aStream
	aStream nextPut: $[; print: self realSubject; nextPut: $].! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 5/8/2005 20:31'!
printString
	^ String streamContents: [ :stream | self printOn: stream ].! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
realSubject
	^ realSubject! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 5/8/2005 20:31'!
realSubject: anObject
	realSubject := anObject! !

SmaCCParser subclass: #MARelationParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Relation'!

!MARelationParser class methodsFor: 'generated-comments' stamp: 'lr 8/13/2005 13:02'!
parserDefinitionComment

	"Start
	: { nil }
	| Expression { #liftFirstValue: } 
	;


# E X P R E S S I O N S

Expression
	: OrExpression { #liftFirstValue: } 
	;

OrExpression
	: OrExpression 'expr1' ""OR"" AndExpression 'expr2' { MAAnyRelation with: expr1 with: expr2 }
	| AndExpression { #liftFirstValue: } 
	;

AndExpression
	: AndExpression 'expr1' ""AND"" NotExpression 'expr2' { MAAllRelation with: expr1 with: expr2 }
	| AndExpression 'expr1' NotExpression 'expr2' { MAAllRelation with: expr1 with: expr2 }
	| NotExpression { #liftFirstValue: } 
	;

NotExpression
	: ""NOT"" NotExpression 'expr' { MANoneRelation with: expr }
	| ""-"" NotExpression 'expr' { MANoneRelation with: expr }
	| ""("" Expression 'expr' "")"" { expr }
	| Relation { #liftFirstValue: } 
	; 


# R E L A T I O N S

Relation
	: Accessor 'accessor' UnaryMessage 'message' { self customize: message with: accessor } 
	| Accessor 'accessor' BinaryMessage 'message' { self customize: message with: accessor } 
	| Accessor 'accessor' KeywordMessage 'message' { self customize: message with: accessor }
	| LiteralValue 'literal' { MAQueryRelation selector: #matches: with: literal }
	;
	
Accessor
	: UnarySelector 'unary' { MASelectorAccessor selector: unary }
	;
	
UnaryMessage
	: UnarySelector 'unary' { MAAccessorRelation selector: unary }
	;
	
BinaryMessage
	: BinarySelector 'binary' LiteralValue 'literal' { MAAccessorRelation selector: binary with: literal }
	;
	
KeywordMessage
	: KeywordSelector 'keyword' LiteralValue 'literal' { MAAccessorRelation selector: keyword with: literal }
	| KeywordMessage 'message' KeywordSelector 'keyword' LiteralValue 'literal' { message setSelector: keyword argument: literal }
	;


# V A L U E S
	
UnarySelector
	: <unary> 'unary' { unary value asSymbol }
	;
	
BinarySelector
	: <binary> 'binary' { binary value asSymbol }
	;
	
KeywordSelector
	: <keyword> 'keyword' { keyword value asSymbol }
	;

LiteralValue
	: ""true"" { true }
	| ""false"" { false }
	| ""nil"" { nil }
	| <number> 'number' { number value asNumber }
	| <string> 'string' { string value copyFrom: 2 to: string value size - 1 }
	;"! !

!MARelationParser class methodsFor: 'generated-accessing' stamp: 'lr 8/13/2005 13:02'!
scannerClass
	^MARelationScanner! !

!MARelationParser class methodsFor: 'generated-starting states' stamp: 'lr 8/13/2005 13:02'!
startingStateForStart
	^1! !

!MARelationParser methodsFor: 'building' stamp: 'lr 5/8/2005 20:31'!
customize: aRelation with: anAccessor
	(MABlockToRelation includesSelector: aRelation selector) 
		ifFalse: [ self error: aRelation selector , ' is an unknown selector.' ].
	^ aRelation setAccessor: anAccessor.! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForAccessor1: nodes 
	^MASelectorAccessor selector: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForAndExpression1: nodes 
	^MAAllRelation with: (nodes at: 1) with: (nodes at: 3)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForAndExpression2: nodes 
	^MAAllRelation with: (nodes at: 1) with: (nodes at: 2)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForBinaryMessage1: nodes 
	^MAAccessorRelation selector: (nodes at: 1) with: (nodes at: 2)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForBinarySelector1: nodes 
	^(nodes at: 1) value asSymbol! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForKeywordMessage1: nodes 
	^MAAccessorRelation selector: (nodes at: 1) with: (nodes at: 2)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForKeywordMessage2: nodes 
	^(nodes at: 1) setSelector: (nodes at: 2) argument: (nodes at: 3)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForKeywordSelector1: nodes 
	^(nodes at: 1) value asSymbol! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForLiteralValue1: nodes 
	^true! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForLiteralValue2: nodes 
	^false! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForLiteralValue3: nodes 
	^nil! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForLiteralValue4: nodes 
	^(nodes at: 1) value asNumber! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForLiteralValue5: nodes 
	^(nodes at: 1) value copyFrom: 2 to: (nodes at: 1) value size - 1! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForNotExpression1: nodes 
	^MANoneRelation with: (nodes at: 2)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForNotExpression2: nodes 
	^MANoneRelation with: (nodes at: 2)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForNotExpression3: nodes 
	^nodes at: 2! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForOrExpression1: nodes 
	^MAAnyRelation with: (nodes at: 1) with: (nodes at: 3)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForRelation1: nodes 
	^self customize: (nodes at: 2) with: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForRelation2: nodes 
	^self customize: (nodes at: 2) with: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForRelation3: nodes 
	^self customize: (nodes at: 2) with: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForRelation4: nodes 
	^MAQueryRelation selector: #matches: with: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForStart1: nodes 
	^nil! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForUnaryMessage1: nodes 
	^MAAccessorRelation selector: (nodes at: 1)! !

!MARelationParser methodsFor: 'generated-reduction actions' stamp: 'lr 8/13/2005 13:02'!
reduceActionForUnarySelector1: nodes 
	^(nodes at: 1) value asSymbol! !

!MARelationParser methodsFor: 'generated-tables' stamp: 'lr 8/13/2005 13:02'!
reduceTable
	^#(
#(17 2 #reduceActionForRelation1:)
#(17 2 #reduceActionForRelation2:)
#(17 2 #reduceActionForRelation3:)
#(17 1 #reduceActionForRelation4:)
#(18 1 #reduceActionForUnaryMessage1:)
#(19 2 #reduceActionForBinaryMessage1:)
#(20 2 #reduceActionForKeywordMessage1:)
#(20 3 #reduceActionForKeywordMessage2:)
#(21 1 #reduceActionForLiteralValue1:)
#(21 1 #reduceActionForLiteralValue2:)
#(21 1 #reduceActionForLiteralValue3:)
#(21 1 #reduceActionForLiteralValue4:)
#(21 1 #reduceActionForLiteralValue5:)
#(22 1 #reduceActionForUnarySelector1:)
#(23 1 #reduceActionForBinarySelector1:)
#(24 1 #reduceActionForKeywordSelector1:)
#(25 2 #reduceActionForNotExpression1:)
#(25 2 #reduceActionForNotExpression2:)
#(25 3 #reduceActionForNotExpression3:)
#(25 1 #liftFirstValue:)
#(26 3 #reduceActionForAndExpression1:)
#(26 2 #reduceActionForAndExpression2:)
#(26 1 #liftFirstValue:)
#(27 3 #reduceActionForOrExpression1:)
#(27 1 #liftFirstValue:)
#(28 1 #reduceFor:)
#(29 0 #reduceActionForStart1:)
#(29 1 #liftFirstValue:)
#(32 1 #liftFirstValue:)
#(33 1 #reduceActionForAccessor1:)
)! !

!MARelationParser methodsFor: 'generated-tables' stamp: 'lr 8/13/2005 13:02'!
transitionTable
	^#(
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 57 25 61 26 65 27 69 29 110 30 73 32 77 33)
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 81 25 77 33)
#(2 46 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 85 25 77 33)
#(2 42 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(2 38 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 57 25 61 26 65 27 89 32 77 33)
#(2 58 1 2 3 4 5 6 7 8 9 10 11 12 13 14 30)
#(2 50 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(2 54 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(2 82 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 18 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 122 10 13 14)
#(2 94 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(3 9 1 13 2 17 3 93 4 102 5 21 6 25 7 29 8 102 9 33 10 37 11 41 12 45 17 49 21 53 22 97 25 102 30 77 33)
#(3 101 5 118 9 118 30)
#(2 0 30)
#(2 114 30)
#(3 33 10 105 13 109 14 113 18 117 19 121 20 125 22 129 23 133 24)
#(2 70 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 74 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 137 9)
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 141 25 77 33)
#(2 90 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(3 9 1 13 2 17 3 21 6 25 7 29 8 33 10 37 11 41 12 45 17 49 21 53 22 57 25 145 26 77 33)
#(2 66 2 6 7 11 12)
#(2 62 2 6 7 11 12)
#(2 6 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 10 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(3 14 1 14 2 14 3 14 4 14 5 14 6 14 7 14 8 14 9 14 10 14 11 14 12 105 13 149 24 14 30)
#(2 22 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(3 13 2 21 6 25 7 37 11 41 12 153 21)
#(3 13 2 21 6 25 7 37 11 41 12 157 21)
#(2 78 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 86 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(3 9 1 13 2 17 3 93 4 98 5 21 6 25 7 29 8 98 9 33 10 37 11 41 12 45 17 49 21 53 22 97 25 98 30 77 33)
#(3 13 2 21 6 25 7 37 11 41 12 161 21)
#(2 26 1 2 3 4 5 6 7 8 9 10 11 12 30)
#(2 30 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
#(2 34 1 2 3 4 5 6 7 8 9 10 11 12 13 30)
)! !

!UndefinedObject methodsFor: '*Magritte-Core-converting' stamp: 'lr 5/8/2005 20:29'!
asLabel
	^ 'n/a'! !

!String methodsFor: '*Magritte-Core-converting' stamp: 'lr 6/15/2005 20:51'!
asLabel
	^ self! !

!String methodsFor: '*Magritte-Core-testing' stamp: 'lr 8/10/2005 21:36'!
matches: aString
	^ (aString includesAnyOf: '*#')
		ifTrue: [ aString match: self ]
		ifFalse: [ self includesSubString: aString ].! !

!Collection methodsFor: '*Magritte-Core-converting' stamp: 'lr 6/15/2005 20:50'!
asLabel
	^ String streamContents: [ :stream |
		self 
			do: [ :each | stream nextPutAll: each asLabel ]
			separatedBy: [ stream nextPutAll: ', ' ] ].! !

!Integer methodsFor: '*Magritte-Core-converting' stamp: 'lr 5/8/2005 20:29'!
asFileSize
	#( 'B' 'KB' 'MB' 'GB' 'TB' 'PB' 'EB' 'ZB' 'YB' )
		inject: self
		into: [ :value :each |
			value < 1024
				ifFalse: [ value // 1024 ]
				ifTrue: [ ^ value asString , ' ' , each ] ].! !

!True methodsFor: '*Magritte-Core-converting' stamp: 'lr 5/8/2005 20:29'!
asLabel
	^ 'yes'! !
MAFileModel initialize!
MAConstantRelation initialize!
